include("Scripts/jsextras.js");
include("Scripts/Source.js");
include("Scripts/Library.js");
include("Scripts/Albums.js");
include("Scripts/UI.js");
include("Scripts/Events.js");
include("Scripts/Player.js");
include("Scripts/Functions.js");
include("Scripts/TrackDisplay.js");
include("Scripts/Buttons.js");
include("Scripts/Widget.js");
include("Scripts/Floater.js");
var iTunesObj = null;
var keySearch = "";
var disableKeyboardHandler = false;
var iconMouseOver = false;
var ReflectionTask;
var hotkeyCurrentAlbum = new HotKey();
var hotkeyCurrentTrack = new HotKey();
var hotkeyRandomAlbum = new HotKey();
var hotkeyFocusWidget = new HotKey();
var hotkeyMinimize = new HotKey();
var hotkeyToggle = new HotKey();
var Const = {
	LibraryFilePath: convertPathToPlatform( system.widgetDataFolder + "/library.xml", true )
	, ArtworkFolder: convertPathToPlatform( system.widgetDataFolder + "/Covers", true )
	, ThumbnailFolder: convertPathToPlatform( system.widgetDataFolder + "/Thumbs", true )
	, ReflectionFolder: convertPathToPlatform( system.widgetDataFolder + "/Reflections", true )
	, NoArtworkImage: "Resources/noartwork_white.png"
	, NoReflectionImage: "Resources/noreflection_white.png"
	, GradientImage: convertPathToPlatform( system.widgetDataFolder + "/reflection_gradient.png", true )
	, CompilationAlbum: "Various Artists"
	, IMFilePath: convertPathToPlatform( system.widgetDataFolder + "/convert.exe", true )
	, WindowsFilePath: convertPathToPlatform( system.widgetDataFolder + "/windows.xml", true )
	, HelpFolder: system.widgetDataFolder + "/Help"
	, HelpFile: system.widgetDataFolder + "/Help/help.html"
	, DockImage: "Resources/dockicon.png"
	
	};
var AlertMsg = {
	StartiTunes: "iTunes need to be started before your iTunes Music Library can be indexed.\n\nDo you want to launch iTunes now and start indexing your Music Library?"
	, RemoveAlbum: "Are you sure you want to remove this album from the Widget?"
	, ReIndexLibrary: "Are you sure you want to reindex your iTunes Music Library?\n\nThis should only be done if your iTunes Music Library has been updated."
	, AddArtwork: "Are you sure you want to add the artwork image to the album in iTunes?"
	, DeleteArtwork: "Are you sure you want to delete the artwork image from this album in iTunes?" 
	};
var StateTimer = new Timer();
with(StateTimer){
	ticking = false;
	onTimerFired = "";
	interval = 10;
	}
var NavigateTimer = new Timer();
with(NavigateTimer){
	ticking = false;
	onTimerFired = "";
	interval = 0.4;
	}
var ResultInfoTimer = new Timer();
with(ResultInfoTimer){
	ticking = false;
	onTimerFired = "UI.CloseResultInfo();";
	interval = 2.0;
	}
var MiniPopupTimer = new Timer();
with(MiniPopupTimer){
	ticking = false;
	onTimerFired = "UI.CloseMiniPopup();";
	interval = 6;
	}
var searchTimer = new Timer();
with(searchTimer){
	ticking = false;
	onTimerFired = "Library.FindFirst();";
	interval = 0.4;
	}
var LevelTimer = new Timer();
with(LevelTimer){
	ticking = false;
	onTimerFired = "Widget.CheckWindowLevel();";
	interval = 15;
	}
var ButtonObjs = new Array();
var PlayButton = new Button(Playbtn, "Resources/playbtn.png", "Resources/playbtn_active.png");
ButtonObjs.push(PlayButton);
with(PlayButton){
	Disable();
	onClickRelease = function(){Player.PlayPause();TrackDisplay.ChangePlayState();};
	}
var ForwardButton = new PressButton(Forwardbtn , "Resources/forwardbtn.png", "Resources/forwardbtn_active.png");
ButtonObjs.push(ForwardButton);
with(ForwardButton){
	Disable();
	onPress = function(){Player.FastForward();};
	onClickRelease = function(){Player.NextTrack();};
	onPressRelease = function(){Player.Resume();TrackDisplay.RefreshTime();};
	onExit = function(){Player.Resume();TrackDisplay.RefreshTime();};
	SetPressTimeout(300);
	}
var RewindButton = new PressButton(Backwardbtn , "Resources/rewindbtn.png", "Resources/rewindbtn_active.png");
ButtonObjs.push(RewindButton);
with(RewindButton){
	Disable();
	onPress = function(){Player.Rewind();};
	onClickRelease = function(){Player.BackTrack();};
	onPressRelease = function(){Player.Resume();TrackDisplay.RefreshTime();};
	onExit = function(){Player.Resume();TrackDisplay.RefreshTime();};
	SetPressTimeout(300);
	}
var iTunesOptionButton = new Button(iTunesoptionbtn, "Resources/itunesoptionbtn.png", "Resources/itunesoptionbtn_active.png");
ButtonObjs.push(iTunesOptionButton);
with(iTunesOptionButton){
	onClickRelease = function(){UI.DropdownMenuHandler("itunes");};
	}
var VolumeDownButton = new Button(Volumedownbtn, "Resources/volumedownbtn.png", "Resources/volumedownbtn_active.png");
ButtonObjs.push(VolumeDownButton);
with(VolumeDownButton){
	Disable();
	onClickRelease = function(){Player.SetVolume(Player.Volume-5);};
	}
var VolumeUpButton = new Button(Volumeupbtn, "Resources/volumeupbtn.png", "Resources/volumeupbtn_active.png");
ButtonObjs.push(VolumeUpButton);
with(VolumeUpButton){
	Disable();
	onClickRelease = function(){Player.SetVolume(Player.Volume+5);};
	}
var PreviousButton = new PressButton(Previousbtn , "Resources/previousbtn.png", "Resources/previousbtn_active.png");
ButtonObjs.push(PreviousButton);
with(PreviousButton){
	Disable();
	onPress = function(){ 
		NavigateTimer.onTimerFired = "Browser.ShowPreviousAlbum();"
		NavigateTimer.ticking = true;
		};
	onClickRelease = function(){
		NavigateTimer.ticking = false;
		Browser.ShowPreviousAlbum();
		};
	onPressRelease = function(){NavigateTimer.ticking = false;};
	onExit = function(){NavigateTimer.ticking = false;};
	}
var NextButton = new PressButton(Nextbtn , "Resources/nextbtn.png", "Resources/nextbtn_active.png");
ButtonObjs.push(NextButton);
with(NextButton){
	Disable();
	onPress = function(){ 
		NavigateTimer.onTimerFired = "Browser.ShowNextAlbum();"
		NavigateTimer.ticking = true;
		};
	onClickRelease = function(){
		NavigateTimer.ticking = false;
		Browser.ShowNextAlbum();
		};
	onPressRelease = function(){NavigateTimer.ticking = false;};
	onExit = function(){NavigateTimer.ticking = false;};
	}

var CloseButton = new Button(Closebtn, "Resources/closebtn.png", "Resources/closebtn.png");
ButtonObjs.push(CloseButton);
with(CloseButton){
	onClickRelease = function(){UI.Iconize();};
	}
var MinimizeButton = new Button(Minimizebtn, "Resources/minimizebtn.png", "Resources/minimizebtn.png");
ButtonObjs.push(MinimizeButton);
with(MinimizeButton){
	Disable();
	onClickRelease = function(){UI.Minimize();};
	}
var SortbyButton = new Button(Sortby, "Resources/sortby.png", "Resources/sortby.png");
ButtonObjs.push(SortbyButton);
with(SortbyButton){
	Disable();
	onPress = function(){
		SortbyButton.MouseDown = false;
		UI.DropdownMenuHandler("sortby");
		};
	}
var PreferencesButton = new Button(Preferencesbtn, "Resources/preferencesbtn.png", "Resources/preferencesbtn.png");
ButtonObjs.push(PreferencesButton);
with(PreferencesButton){
	Disable();
	onClickRelease = function(){ showWidgetPreferences(); };
	}
var AlbumOptionButton = new Button(Albumoptionbtn, "Resources/albumoptionsbtn.png", "Resources/albumoptionsbtn.png");
ButtonObjs.push(AlbumOptionButton);
with(AlbumOptionButton){
	Disable();
	onClickRelease = function(){
		AlbumOptionButton.MouseDown = false;
		UI.DropdownMenuHandler("album");
		};
	}
Widget.Init();
