var Albums = {
	_data: new Array()
	, _keys: new Object()
	, HashKeys: function(){
		this._keys = new Object();
		this._data.forEach( function(element, index){this._keys[element.Id] = index;}, this );
		}
	, SetSearchData: function(searchdata){
		if(!UI.SearchMode){
			this._dataCopy = this._data;
			this._keysCopy = this._keys;
			}
		this._data = searchdata;
		}
	, Count: function(){
		return this._data.length;
		}
	, IndexOf: function(key){
		return this._keys[key];
		}
	, Exists: function(key){
		if(UI.SearchMode){
			return (this._keysCopy[key] != null);
			}
		else{
			return (this.IndexOf(key) != null);
			}
		}
	, ItemByIndex: function(index){
		return this._data[index];
		}
	, ItemByKey: function(key){
		var index = this.IndexOf(key);
		return (index != null)?this._data[index]:null;
		}
	, GetCount: function(key){
		if(UI.SearchMode){
			return this._dataCopy.length;
			}
		else{
			return this.Count();
			}
		}
	, GetAlbum: function(key){
		if(UI.SearchMode){
			var index = this._keysCopy[key];
			return this._dataCopy[index];
			}
		else{
			return this.ItemByKey(key);
			}
		}
	, Add: function(album){
		this._data.push(album);
		this._keys[album.Id] = this._data.length -1;
		}
	, Insert: function(album){
		if(UI.SearchMode){
			Library.SortAfterSearch = true;
			this._dataCopy.push(album);
			this._keysCopy[album.Id] = this._dataCopy.length -1;
			}
		else{
			this.Add(album);
			}
		Source.Add(album);
		}
	, Remove: function(key){
		var index = this.IndexOf(key);
		this._data.splice(index,1);
		this.HashKeys();
		if(UI.SearchMode){
			Library.SortAfterSearch = true;
			var index = this._keysCopy[key];
			this._dataCopy.splice(index,1);
			delete this._keysCopy[key];
			}
		Source.Remove(key);
		}
	, Update: function(oldKey, album){
		var index = this.IndexOf(oldKey);
		this._data[index] = null;
		this._data[index] = album;
		if(UI.SearchMode){
			Library.SortAfterSearch = true;
			var index = this._keysCopy[oldKey];
			this._dataCopy[index] = null;
			this._dataCopy[index] = album;
			if(oldKey != album.Id){
				delete this._keysCopy[oldKey];
				this._keys[album.Id] = index;
				}
			}
		Source.Update(oldKey, album);
		album = null;
		}
	, Clear: function(){
		this._data = new Array();
		this._keys = new Object();
		}
	, Search: function(searchterm, type){
		var result;
		var searchdata = new Array();
		var ArrData = (UI.SearchMode)?this._dataCopy:this._data;
		switch(type){
			case 1:
				searchdata = ArrData.filter(
					function(album){
						var regexp = new RegExp(searchterm, "gi");
						return (regexp.test(album.Title) || regexp.test(album.Artist)); 
						} 
					);
				result = searchdata.length;
				if(result > 0){
					this.SetSearchData(searchdata);
					}
				else{
					searchdata = null;
					}
				break;
			case 2:
				searchdata = ArrData.filter( function(album){ return album.Artist.toLowerCase() == searchterm; } );
				result = searchdata.length;
				if(result > 0){
					this.SetSearchData(searchdata);
					}
				else{
					searchdata = null;
					}
				break;
			case 3:
				var slength = searchterm.length;
				var currentSort = UI.SortMethod;
				var numAlbums = this.Count();
				var index = null;
				for(var j = 0;j < numAlbums; j++){
					if(((currentSort == 1)?this._data[j].Title:this._data[j].Artist).substr(0, slength).toLowerCase() == searchterm){
						index = j;
						break;
						}
					}
				result = index;
			 	break;
			}
		return result;
		}
	, Sort: function(method){
		this._data.sort(method);
		this.HashKeys();
		}
	, Reverse: function(){
		this._data.reverse();
		this.HashKeys();
		}
	, RestoreData: function(sort){
		this._data = this._dataCopy;
		if(sort){
			this._keysCopy = null;
			}
		else{
			this._keys = this._keysCopy;
			}
		this._dataCopy = null;
		this._keysCopy = null;
		}
	, GenerateReflections: function(){
		try{
			var ArrKeys = (UI.SearchMode)?this._keysCopy:this._keys;
			for (var key in this._keys){		
				var album = this.GetAlbum(key);
				if(album != null){
					if(album.HasArtwork && !album.HasReflection){
						var pathToThumbnail = "\"" + convertPathToPlatform( album.GetThumbnailPath(), true ) + "\"";
						var pathToReflection = "\"" + convertPathToPlatform( Const.ReflectionFolder +"/"+ album.ArtworkName, true ) + "\"";
						var tag = "ReflectionTask";
						var cmd = fxGetReflectionCmd(pathToThumbnail, pathToReflection);
						var ref = album.Id;
						var callback = function(key, data){ Albums.ReflectionCallback(key, data); }
						Widget.TaskHandler.Push( new TaskItem(tag, cmd, ref, callback) );
						} // end if
					} // end if
				album = null;
				} // end for
			if(Widget.TaskHandler.Count() > 0){
				Widget.TaskHandler.Start();
				return true;
				}
			else{
				return false;
				}
			}
		catch(ex){
			log("__Error creating artwork reflections: " + ex);
			}
		}
	, ReflectionCallback: function(key, result){
		try{
			if(result != ""){
				log("__Error running runCommandInBg to create reflection image: " + result);
				return;
				}
			if( this.Exists(key) ){
				var album = this.GetAlbum(key);
				album.HasReflection = true;
				this.Update(key, album);
				}
			}
		catch(ex){
			log("__Error updating album after creating artwork reflection: " + ex);
			}
		}
	};
function Album(key, title, artist){
	this.Id = key;
	this.Title = title;
	this.Artist = artist;
	this.Year = 0;
	this.DateAdded = "";
	this.TrackCount = 0;
	this.RatedTrackCount = 0;
	this.TotalRating = 0;
	this.AverageRating = 0;
	this.HasArtwork = false;
	this.HasReflection = false;
	this.ArtworkName = "";
	this.ArtworkSource = 0;
	}
Album.prototype = {
	AddTrack: function(track){
		this.SetRating(track.Rating);			
		if(this.TrackCount == 1){
			this.Year = track.Year;
			this.DateAdded = track.DateAdded;
			if(track.Artwork.Count > 0){
				this.SaveArtwork(track.Artwork);
				}
			else{
				if(preferences.IndexSearchInFolder.value == 1){
					this.SearchForArtwork(track.Location);
					}
				}
			}
		}
	, SetRating: function(rating){
		this.TrackCount += 1;
		if(rating > 0){
			this.TotalRating += rating;
			this.RatedTrackCount += 1;
			}
		this.AverageRating = Math.round(this.TotalRating / this.TrackCount);
		}
	, SaveArtwork: function(Artwork){
		try{
			var fileName = cleanString(this.Artist +"-"+ this.Title);
			var fileExtention = fxGetArtworkFormat(Artwork.Item(1).Format);
			if(fileExtention != null){
				fileName = fileName + fileExtention;
				var filePath = convertPathToPlatform(Const.ArtworkFolder + "/" + fileName, true);
				Artwork.Item(1).SaveArtworkToFile(filePath);
				this.ArtworkName = fileName;
				this.ArtworkSource = 1;
				this.HasArtwork = true;
				this.CreateThumbnail();
				if(UI.AlbumReflection){
					this.HasReflection = this.CreateReflection();
					}
				}
			else{
				this.HasArtwork = false;
				}
			}
		catch(ex){
			this.HasArtwork = false;
			log( "__Error saving artwork from iTunes track to file: " + ex );
			}
		}
	, SearchForArtwork: function(trackPath){
		try{
			var folderPath = trackPath.substring(0, trackPath.lastIndexOf("\\"));
			var imagePath = convertPathToPlatform( folderPath + "/folder.jpg" , true);
			if( filesystem.itemExists(imagePath) ){
				var newFileName = cleanString(this.Artist +"-"+ this.Title) + ".jpg";
				var newFilePath = convertPathToPlatform(Const.ArtworkFolder + "/" + newFileName, true);
				filesystem.copy( imagePath, newFilePath );
				this.ArtworkName = newFileName;
				this.ArtworkSource = 2;
				this.HasArtwork = true;
				this.CreateThumbnail();
				if(UI.AlbumReflection){
					this.HasReflection = this.CreateReflection();
					}
				}
			}
		catch(ex){
			this.HasArtwork = false;
			log( "__Error copying artwork from album folder: " + ex );
			}
		}
	, CreateThumbnail: function(){
		try{
			var pathToArtwork = "\"" + convertPathToPlatform( this.GetArtworkPath(), true ) + "\"";
			var pathToThumbnail = "\"" + convertPathToPlatform( this.GetThumbnailPath(), true ) + "\"";
			return fxRunThumbnailCmd(pathToArtwork, pathToThumbnail);
			}
		catch(ex){
			log("__Error running thumbnail cmd: " + ex);
			}
		}
	, CreateReflection: function(){
		var result;
		try{
			var pathToThumbnail = "\"" + convertPathToPlatform( this.GetThumbnailPath(), true ) + "\"";
			var pathToReflection = "\"" + convertPathToPlatform( Const.ReflectionFolder +"/"+ this.ArtworkName, true ) + "\"";
			result = fxRunReflectionCmd(pathToThumbnail, pathToReflection);
			}
		catch(ex){
			result = false;
			log("__Error running reflection cmd: " + ex);
			}
		return result;
		}
	, GetArtworkPath: function(){
		return (this.HasArtwork)?Const.ArtworkFolder +"/"+ this.ArtworkName:Const.NoArtworkImage;
		}
	, GetThumbnailPath: function(){
		return (this.HasArtwork)?Const.ThumbnailFolder +"/"+ this.ArtworkName:Const.NoArtworkImage;
		}
	, GetReflectionPath: function(){
		return (this.HasReflection)?Const.ReflectionFolder +"/"+ this.ArtworkName:Const.NoReflectionImage;
		}
	};

