function iTunes_OnAboutToPromptUserToQuitEvent(){
	log("__iTunes_OnAboutToPromptUserToQuitEvent");
	StateTimer.reset();
	Widget.CurrentStatus = "stopping";
	Player.DisconnectEvents();
	fxCloseCurrentState();
	}
function iTunes_OnQuittingEvent(){
	log("__iTunes_OnQuittingEvent");
	Player.DisconnectEvents();
	}
function iTunes_OnPlayerStopEvent(){
	log("__iTunes_OnPlayerStopEvent__");
	try{
		Player.ClearTrack();
		TrackDisplay.ChangePlayState();
		if( Player.IsPaused() ){
			if(UI.TrackDisplay){
				TrackDisplay.Stop();
				}
			if(UI.MiniPopup && UI.OverrideMiniPopup){
				UI.CloseMiniPopup();
				}
			}
		else{
			if(!Player.IsPlaying()){
				fxCloseCurrentState();
				}
			}
		}
	catch(ex){
		log( "__Error in iTunes_OnPlayerStopEvent: " + ex );
		}
	}
function iTunes_OnPlayerPlayingTrackChangedEvent(track){
	log("__iTunes_OnPlayerPlayingTrackChangedEvent__");
	try{
		Player.ChangeTrack(track);
		if(UI.Busy){
			log("__Aborting iTunes_OnPlayerPlayingTrackChangedEvent__");
			return;
			}
		if(UI.MiniPopup){
			Player.DisplayPlayingTrack();
			}
		if(UI.TrackDisplay && !UI.Iconized){
			TrackDisplay.Refresh(true);
			}
		if(UI.DockVitality){
			Player.DockPlayingTrack();
			}
		}
	catch(ex){
		log( "__Error in iTunes_OnPlayerStopEvent: " + ex );
		}
	}
function iTunes_OnPlayerPlayEvent(track){
	log("__iTunes_OnPlayerPlayEvent: " + track.Name );
	try{
		Player.ChangeTrack(track);
		if(UI.Busy){
			log("__Aborting iTunes_OnPlayerPlayEvent__");
			return;
			}
		if(!UI.Iconized){
			if(UI.TrackDisplay){
				TrackDisplay.Change(track);
				}
			TrackDisplay.ChangePlayState();
			}
		var trackInfo = Player.GetTrack();
		var artist = trim(trackInfo.Artist);
		var albumtitle = trim(trackInfo.Album);
		var albumImported = false;
		var isFiletrack = trackInfo.IsFileTrack;
		var key = fxGenerateAlbumId(artist, albumtitle, trackInfo.IsCompilation);
		var skipAction = ( trackInfo.IsVideo || (!Library.UseCompilation && trackInfo.IsCompilation) || trackInfo.IsPodcast );
		if((UI.AutoImport || UI.MiniPopup || UI.DockVitality) && !UI.Busy){
			var isNewAlbum = false;
			var hasArtwork = false;
			var artworkpath;
			if(!isFiletrack){
				isNewAlbum = false;
				artworkpath = Const.NoArtworkImage;
				}
			else{
				if(UI.MiniPopup || UI.DockVitality){
					var album;
					if(Albums.Exists(key)){
						album = Albums.GetAlbum(key);
						}
					else{
						isNewAlbum = true;
						}
					if(!isNewAlbum){
						artworkpath = album.GetThumbnailPath();
						}
					else{
						artworkpath = Player.SaveArtworkToFile(track.Artwork, system.widgetDataFolder, "MiniPopupArtwork");
						}
					album = null;
					}
				}
			if(isNewAlbum && skipAction){ isNewAlbum = false; }
			if(UI.MiniPopup && !UI.Busy){
				UI.ShowMiniPopup(artworkpath, isNewAlbum);
				}
			if(UI.DockVitality){
				Widget.SetDockInfo(artworkpath, (!trackInfo.IsStream)?trackInfo.Rating:null);
				}
			if(UI.AutoImport && isNewAlbum && isFiletrack && !skipAction && !UI.Busy){
				if(albumtitle != "" && artist != ""){
					albumImported = Library.ImportAlbum(key, (trackInfo.IsCompilation)?Const.CompilationAlbum:artist, albumtitle);
					}
				}
			}
		if(!albumImported){
			if(UI.AutoScroll && !skipAction && isFiletrack && !UI.Busy && !UI.Minimized && !UI.SearchMode){
				if(!isNewAlbum){
					Browser.ShowAlbumByKey(key);
					}
				}
			}
		else{
			if(!UI.SearchMode){
				if(UI.Minimized){ UI.Minimize(); }
				Browser.ShowAlbumByKey(key);
				}
			}
		track = null;
		}
	catch(ex){
		log( "__Error in iTunes_OnPlayerPlayEvent: " + ex );
		}
	}
