var Floater = {
	_windows: new Array()
	, _keys: new Object()
	, Size: 2
	, Count: function(){
		return this._windows.length;
		}
	, Exists: function(key){
		return this._keys[key] != null;
		}
	, IndexOf: function(key){
		return this._keys[key];
		}
	, ItemByKey: function(key){
		var index = this.IndexOf(key);
		return (index != null)?this._windows[index]:null;
		}
	, ItemByIndex: function(index){
		return this._windows[index];
		}
	, HashKeys: function(){
		this._keys = new Object();
		this._windows.forEach( function(element, index){this._keys[element.key] = index;}, this );
		}
	, SetSize: function(size){
		this.Size = size;
		this._windows.forEach( function(element){element.Update();}, this );
		}
	, GetSize: function(){
		var size = 155;
		switch(this.Size){
			case "2":
				size = 155;
				break;
			case "1":
				size = 100;
				break;
			case "0":
				size = 50;
				break;
			}
		return size;
		}
	, Add: function(key){
		if(!this.Exists(key)){
			this.Create(key);
			this.Save();
			}
		else{
			this.Update(key);
			}
		}
	, Create: function(key, hOffset, vOffset){
		this._windows.push(new AlbumWindow(key, hOffset, vOffset));
		this._keys[key] = this._windows.length-1;
		}
	, Close: function(key){
		var index = this.IndexOf(key);
		if(index != null){
			this.ItemByIndex(index).Close();
			this._windows.splice(index,1);
			this.HashKeys();
			this.Save();
			}
		}
	, Update: function(key){
		this.ItemByKey(key).Update();
		}
	, CloseAll: function(){
		try{
			var winCount = this.Count();
			for(var i = 0; i < winCount; i++){
				this.ItemByIndex(i).Close();
				}
			this._windows = null;
			this._windows = new Array();
			this._keys = null;
			this._keys = new Object();
			this.Save();
			}
		catch(ex){
			log("__Error closing all floater windows: " + ex);
			}
		}
	, RestorePositions: function(){
		var winCount = this.Count();
		for(var i = 0; i < winCount; i++){
			this.ItemByIndex(i).ResetPosition();
			}
		}
	, ContextMenuHandler: function(key){
		try{
			var items = new Array();
			var currentalbum = Albums.GetAlbum(key);
			var iTunesIsRunning = Player.IsRunning();
			items.push( getMenuHeader( truncateString(currentalbum.Artist, 30) ) );
			items.push( getMenuHeader( truncateString(currentalbum.Title, 30) ) );
			items.push( getMenuSeparator() );
			items.push( getMenuItem("Close Album Window", "Floater.Close('"+ key +"');", true) );
			items.push( getMenuSeparator() );
			items.push( getMenuItem("Play Album", "Player.PlayAlbum('"+ key +"');", iTunesIsRunning) );
			items.push( getMenuItem("Add Album to Playlist", "Player.AddAlbum('"+ key +"');", iTunesIsRunning) );
			items.push( getMenuItem("Show Artwork...", "UI.ShowArtworkWindow('"+ key +"');", true) );
			items.push( getMenuSeparator() );
			items.push( getMenuItem("Show Album", "Floater.Actions.ShowAlbum('"+ key +"');", true) );
			items.push( getMenuItem("Show All Albums by Artist", "Floater.Actions.ShowAllAlbums(\""+ currentalbum.Artist +"\");", true) );
			items.push( getMenuSeparator() );
			items.push( getMenuItem("Refresh Album", "Floater.Actions.RefreshAlbum('"+ key +"');", iTunesIsRunning && !UI.Iconized) );
			items.push( getMenuItem("Remove Album", "Floater.Actions.RemoveAlbum('"+ key +"');", !UI.Iconized) );
			this.ItemByKey(key).window.contextMenuItems = items;
			currentalbum = null;
			}
		catch(ex){
			log("__Error creating context menu on album window: " + ex);
			}
		}
	, Init: function(){
		log("pner dokument for vinduer")
		try{
			if(filesystem.itemExists(Const.WindowsFilePath)){
				var doc = XMLDOM.parse( filesystem.readFile( Const.WindowsFilePath ) );
				var windows = doc.documentElement.childNodes;
				var numWindows = windows.length;
				for(var i = 0; i < numWindows; i++){
					var node = windows.item(i);
					var hOffset = node.getAttribute("hOffset");
					var vOffset = node.getAttribute("vOffset");
					if( hOffset < 0 || hOffset > screen.availWidth){
						hOffset = Math.round( (screen.availWidth - this.GetSize())/2 );
						}
					if(vOffset < 0 || vOffset > screen.availHeight){
						vOffset = Math.round( (screen.availHeight - this.GetSize())/2 );
						}
					this.Create( node.getAttribute("key"), hOffset, vOffset );
					node = null;
					}
				}
			}
		catch(ex){
			log("__Error loading saved album windows: "+ ex);
			}
		}
	, Save: function(){
		try{
			var doc = XMLDOM.createDocument();
			var root = doc.createElement("windows");
			doc.appendChild(root);
			var winCount = this.Count();
			for(var i = 0; i < winCount; i++){
				var win = this.ItemByIndex(i);
				var node = doc.createElement("window");
				node.setAttribute("key", win.key);
				node.setAttribute("vOffset", win.vOffset);
				node.setAttribute("hOffset", win.hOffset);
				root.appendChild(node);
				node = null;
				}
			filesystem.writeFile( Const.WindowsFilePath, doc.toXML() );
			}
		catch(ex){
			log("__Error saving window position to disk: "+ ex);
			}
		}
	, Actions: {
		RemoveAlbum: function(key){
			if(UI.Minimized){ UI.Minimize(); }
			if(UI.SearchMode){ UI.CloseSearch(); }
			Browser.ShowAlbumByKey(key);
			Library.RemoveAlbum(key);
			}
		, RefreshAlbum: function(key){
			if(UI.SearchMode){ UI.CloseSearch(); }
			if(UI.Minimized){ UI.Minimize(); }
			Browser.ShowAlbumByKey(key);
			Library.RefreshAlbum(key);
			}
		, ShowAlbum: function(key){
			if(UI.Iconized){ UI.Iconize(); }
			if(UI.Minimized){ UI.Minimize(); }
			if(UI.SearchMode){ UI.CloseSearch(); }
			Browser.ShowAlbumByKey(key);
			}
		, ShowAllAlbums: function(artist){
			if(UI.Iconized){ UI.Iconize(); }
			if(UI.Minimized){ UI.Minimize(); }
			Library.ShowAlbumsByArtist(artist);
			}
		, AlbumActionHandler: function(key){
			switch(preferences.AlbumAction.value){
				case "1":
					Player.PlayAlbum(key);
					break; 
				case "2":
					Player.AddAlbum(key);
					break;
				case "3":
					UI.ShowArtworkWindow(key);
					break;
				}
			}
		}
	, Events: {
		Position: { x:0 , y:0 }
		, MouseDownHandler: function(key){
			this.Position.x = system.event.hOffset;
			this.Position.y = system.event.vOffset;
			}
		, MouseDragHandler: function(key){
			Floater.ItemByKey(key).SetPosition( (system.event.screenX-this.Position.x), (system.event.screenY-this.Position.y) );
			}
		}
	};
function AlbumWindow(key, hOffset, vOffset){
	this.key = key;
	this.window = null;
	this.image = null;
	this.vOffset = vOffset;
	this.hOffset = hOffset;
	this.Load();
	this.SetEvents();
	}
AlbumWindow.prototype.Load = function(){
	try{
		var currentalbum = Albums.ItemByKey(this.key);
		var title = currentalbum.Title;
		var artist = currentalbum.Artist;
		var size = Floater.GetSize();
		this.window = new Window();
		with(this.window){
			title = "iTunes Album Browser";
			visible = false;
			shadow = true;
			width = size;
			height = size;
			}
		this.SetPosition(this.hOffset || Math.round( (screen.availWidth - fxRandomNumber(0,size))/2 ), this.vOffset || Math.round( (screen.availHeight - fxRandomNumber(0,100))/2 ) );
		this.image = new Image();
		with(this.image){
			visible = true;
			src = currentalbum.GetThumbnailPath();
			width = size;
			height = size;
			vOffset = 0;
			hOffset = 0;
			var tracks = currentalbum.TrackCount
			var ratedtracks = currentalbum.RatedTrackCount
			var ratedinfo = (tracks == ratedtracks)?"":"  ("+ ratedtracks +" rated)";
			tooltip = artist + "\n" + title + "\n\nYear: " + currentalbum.Year + "\nTracks: " + tracks + ratedinfo + "\nAverage Rating: " + fxGetAverageRating(currentalbum.AverageRating) + "\n\nClick and drag to move. Right click for options."
			onContextMenu = "Floater.ContextMenuHandler('"+ this.key +"');";
			onMultiClick = "if(system.event.clickCount == 2){ Floater.Actions.AlbumActionHandler('"+ this.key +"'); }";	
			}
		this.window.root.addSubview( this.image );
		var textcolor = (preferences.DefaultArtwork.value == "black")?"#FFFFFF":"#000000";
		if(Floater.Size == "2" && !currentalbum.HasArtwork){
			var artistTxt = new Text();
			with(artistTxt){
				color = textcolor;
				data = artist;
				font = "Tahoma";
				size = "10";
				width = "135";
				vOffset = "125";
				hOffset = "10";
				style.KonTextTruncation = "end";
				}
			this.window.root.addSubview( artistTxt );	
			var titleTxt = new Text();
			with(titleTxt){
				color = textcolor;
				data = title;
				font = "Tahoma";
				size = "10";
				width = "145";
				vOffset = "140";
				hOffset = "10";
				style.KonTextTruncation = "end";
				}
			this.window.root.addSubview( titleTxt );
			}
		this.window.visible = true;
		this.window.focus();
		currentalbum = null;
		}
	catch(ex){
		log("__Error creating album window: " + ex);
		}
	}
AlbumWindow.prototype.SetEvents = function(){
	try{
		this.image.onMouseDown = "Floater.Events.MouseDownHandler('"+ this.key +"');"
		this.image.onMouseDrag = "Floater.Events.MouseDragHandler('"+ this.key +"')";
		}
	catch(ex){
		log("__Error setting events on album window: " + ex);
		}
	}
AlbumWindow.prototype.Close = function(){
	try{
		this.window.visible = false;
		for(var j = this.window.root.subviews.length-1;j >= 0;j--){			
			this.window.root.subviews[j].removeFromSuperview();
			}
		this.window = null;
		}
	catch(ex){
		log("__Error closing album window: " + ex);
		}
	}
AlbumWindow.prototype.Update = function(){
	try{
		this.Close();
		this.Load();
		this.SetEvents()
		}
	catch(ex){
		log("__Error setting events on album window: " + ex);
		}
	}
AlbumWindow.prototype.SetPosition = function(hOffset, vOffset){
	this.hOffset = this.window.hOffset = hOffset;
	this.vOffset = this.window.vOffset = vOffset;
	}
AlbumWindow.prototype.ResetPosition = function(){
	this.window.hOffset = this.hOffset;
	this.window.vOffset = this.vOffset;
	}
AlbumWindow.prototype.Focus = function(){
	this.window.focus();
	}
