function fxInitTrackDisplay(){
	try{
		if(Player.IsRunning()){
			TrackDisplay.ChangePlayState();
			if(Player.IsPlaying()){
				if(UI.TrackDisplay){
					TrackDisplay.Refresh(false);
					}
				if(UI.AutoScroll && !UI.Minimized){
					if(Player.Track.Kind == "file track"){
						if(!Player.Track.IsPodcast && !Player.Track.IsVideo){
							Player.DisplayPlayingAlbum();
							}
						track = null;
						}
					}
				if(UI.MiniPopup){
					Player.DisplayPlayingTrack();
					}
				if(UI.DockVitality){
					Player.DockPlayingTrack();
					}
				}
			}
		}
	catch(ex){
		log("__Error init TrackDisplay: " + ex);
		}
	}
function fxCheckTrackDisplay(){
	try{
		if( Player.IsRunning() ){
			TrackDisplay.ChangePlayState();
			if( UI.TrackDisplay && Player.IsPlaying() ){
				TrackDisplay.Refresh(true);
				}
			}
		}
	catch(ex){
		log("__Error check TrackDisplay: " + ex);
		}
	}
function fxCloseCurrentState(){
	if(UI.TrackDisplay){
		TrackDisplay.Clear();
		}
	if(UI.MiniPopup && UI.OverrideMiniPopup){
		UI.CloseMiniPopup();
		}
	if(UI.DockVitality){
		Widget.SetDockInfo(Const.DockImage, null);
		}
	}
function getSortByMenuItems(indent){
	var items = new Array();
	items.push( getCheckMenuItem( "Album"			, "UI.ChangeSortMethod(1);", (UI.SortMethod == 1), true) );
	items.push( getCheckMenuItem( "Artist + Album"	, "UI.ChangeSortMethod(2);", (UI.SortMethod == 2), true) );
	items.push( getCheckMenuItem( "Artist + Year"	, "UI.ChangeSortMethod(3);", (UI.SortMethod == 3), true) );
	items.push( getCheckMenuItem( "Year"			, "UI.ChangeSortMethod(4);", (UI.SortMethod == 4), true) );
	items.push( getCheckMenuItem( "Average Rating"	, "UI.ChangeSortMethod(5);", (UI.SortMethod == 5), true) );
	items.push( getCheckMenuItem( "Random"			, "UI.ChangeSortMethod(6);", (UI.SortMethod == 6), true) );
	items.push( getCheckMenuItem( "Date Added"		, "UI.ChangeSortMethod(7);", (UI.SortMethod == 7), true) );
	items.push( getMenuSeparator() );		
	items.push( getCheckMenuItem( "Reverse Sort Order", "UI.ReverseSortOrder();", UI.SortReversed, true) );
	return items;
	}
function getRatingMenuItems(rating){
	var items = new Array();
	items.push( getMenuHeader("Track Rating:") );
	items.push( getCheckMenuItem("  None", "Player.SetTrackRating(0);", (rating == 0), true ) );
	for(var i=1;i<=10;i++){
		var value = (i * 10);
		var star = (value/10)/2
		items.push( getCheckMenuItem("  "+ star, "Player.SetTrackRating("+  value +");", (rating == value), true ) );
		}
	return items;
	}
function getPlaylistMenuItems(){
	var item;
	if(Player.PlaylistCache == null){
		Player.CachePlaylists();
		}
	item = getMenuItem( "Playlists", "", true );
	var currentPlaylist = Player.GetCurrentPlaylist();
	var currentName = (currentPlaylist != null)?currentPlaylist.Name:"None";
	var playlistCount = Player.PlaylistCache.length;
	for(var i = 0;i < playlistCount; i++){
		var name = Player.PlaylistCache[i];
		item.appendChild( getCheckMenuItem( name, "Player.PlayPlaylist('"+ name +"');", (currentName == name), true) );
		}
	item.appendChild( getMenuSeparator() );
	item.appendChild( getMenuItem("Refresh Playlist List", "Player.CachePlaylists();", true) );
	return item;
	}
function getMenuItem(title, call, enabled){
	var item = new MenuItem();
	item.title = title;
	item.onSelect = call;
	item.enabled = enabled;
	return item;
	}
function getCheckMenuItem(title, call, checked, enabled){
	var item = new MenuItem();
	item.title = title;
	item.onSelect = call;
	item.checked = checked;
	item.enabled = enabled;
	return item;
	}
function getMenuHeader(title){return getMenuItem(title, "", false);}
function getMenuSeparator(){return getMenuItem("-", "", false);}
function fxRunThumbnailCmd(ArtworkPath, ThumbnailPath){
	var result = runCommand( "\"" + Const.IMFilePath + "\" " + ArtworkPath + " -resize \"155x155>\" " + ThumbnailPath );
	if(result != ""){
		log("__Error running runCommand to create thumbnail image: " + result);
		return false;
		}
	else{
		return true;
		}
	}
function fxRunReflectionCmd(thumbnailPath, reflectionPath){
	var result = runCommand( fxGetReflectionCmd(thumbnailPath, reflectionPath) );
	if(result != ""){
		log("__Error running runCommand to create reflection image: " + result);
		return false;
		}
	else{
		return true;
		}
	}
function fxGetReflectionCmd(thumbnailPath, reflectionPath){
	var cmd = "\""+ Const.IMFilePath +"\" "+ thumbnailPath +" -flip -crop 155x30+0+0 \""+ Const.GradientImage +"\" -composite "+ reflectionPath;
	return cmd;
	}
function fxIsVideo(track){
	var result;
	try{
		if(track.Kind >= 3){
			result = false;
			}
		else{
			result = (iTunes.Version >= "7")?(track.VideoKind > 0):(track.KindAsString.indexOf("MPEG-4 video") > -1);
			}
		}
	catch(ex){
		result = false;
		}
	return result;
	}
function fxGetIconTooltip(){
	return "iTunes Album Browser "+ ((Widget.Sleeping)?"(hibernated)":"") +"\nContaining "+ Albums.GetCount() +" albums \n\nClick to open, Ctrl + click to move";
	}	
function fxSetLibraryCompatible(version){
	switch(version){
		case "2.0":
			preferences.Version2Compatible.value = 1;
			break;
		case "2.2":
			preferences.Version22Compatible.value = 1;
			break;
		case "2.3":
			preferences.Version23Compatible.value = 1;
			break;
		case "2.3.1":
			preferences.Version231Compatible.value = 1;
			break;
		}
	savePreferences();
	}
function fxSetHotkey(hotkey, enable, shortcut, fx){
	var index = shortcut.lastIndexOf("+");
	hotkey.modifier = shortcut.substring(0, index);
	hotkey.key = shortcut.substr( index+1 );
	hotkey.onKeyDown = (enable && shortcut!="")?fx:"print('hotkey disabled');";
	}
function fxGenerateAlbumId(artist, title, compilation){
	var pattern = new RegExp(/\W/g);
	artist = (!compilation)?artist.replace(pattern, ""):Const.CompilationAlbum;
	title = title.replace(pattern, "");
	return artist.toLowerCase()+"-"+title.toLowerCase();
	}
function fxArtworkImageSearch(service){
	try{
		var currentalbum = Albums.GetAlbum(UI.ArtworkAlbumKey);
		var artist = currentalbum.Artist;
		var title = currentalbum.Title;
		currentalbum = null;
		var searchTerm = "";
		var searchUrl = "";
		if(artist.indexOf(" ") > -1){
			searchTerm = escape("\""+ artist +"\"");
			}
		else{
			searchTerm = escape( artist );
			}
		if(title.indexOf(" ") > -1){
			searchTerm += " " + escape("\""+ title +"\"");
			}
		else{
			searchTerm += " " + escape( title );
			}		
		switch(service){
			case "google":
				searchUrl = "http://images.google.com/images?q=" + searchTerm;
				break;
			case "yahoo":
				searchUrl = "http://images.search.yahoo.com/search/images?p=" + searchTerm;
				break;
			case "windowslive":
				searchUrl = "http://www.live.com/#q=" + searchTerm + "&scope=images";
				break;
			}
		if(searchUrl != ""){
			openURL(searchUrl);
			}
		}
	catch(ex){
		log("__Error searching for artwork image: " + ex);
		}
	}
function fxVideoSearch(service, artist, name){
	try{
		var searchUrl = "";
		var searchTerm = "";
		if(artist.indexOf(" ") > -1){
			searchTerm = escape("\""+ artist +"\"");
			}
		else{
			searchTerm = escape( artist );
			}
		if(name.indexOf(" ") > -1){
			searchTerm += " " + escape("\""+ name +"\"");
			}
		else{
			searchTerm += " " + escape( name );
			}
		switch(service){
			case "google":
				searchUrl = "http://video.google.com/videosearch?q=" + searchTerm;
				break;
			case "yahoo":
				searchUrl = "http://video.yahoo.com/video/search?p=" + searchTerm;
				break;
			case "youtube":
				searchUrl = "http://youtube.com/results?search_query=" + searchTerm;
				break;
			}
		if(searchUrl != ""){
			openURL(searchUrl);
			}
		}
	catch(ex){
		log("__Error opening video search: " + ex);
		}
	}
function fxServicesPandora(type, text){
	try{
		var searchUrl = "";
		switch(type){
			case "artist":
				searchUrl = "http://www.pandora.com/?searchFilter=artist&search=" + escape(text);
				break;
			case "song":
				searchUrl = "http://www.pandora.com/?searchFilter=song&search=" + escape(text);
				break;
			}
		if(searchUrl != ""){
			openURL(searchUrl);
			}
		}
	catch(ex){
		log("__Error opening Last.fm link: " + ex);
		}
	}
function fxServicesLastfm(type, artist, album){
	try{
		var searchUrl = "";
		if(artist.indexOf("/") >= 0){
			artist = artist.replace("/", escape(escape("/")) );
			}
		switch(type){
			case "artist":
				searchUrl = "http://www.last.fm/music/" + urlString(artist);
				break;
			case "album":
				if(album.indexOf("/") >= 0){
					album = album.replace("/", escape(escape("/")) );
					}
				searchUrl = "http://www.last.fm/music/" + urlString(artist) + "/" + urlString(album);
				break;
			case "similar":
				searchUrl = "http://www.last.fm/music/" + urlString(artist) + "/+similar";
				break;
			}
		if(searchUrl != ""){
			openURL(searchUrl);
			}
		}
	catch(ex){
		log("__Error opening Last.fm link: " + ex);
		}
	}
function fxGetArtworkFormat(format){
	var fileExtention = null;
	switch(format){
		case 0: // Unknown Artwork format, abort...
			fileExtention =  null;
			break;
		case 1: // jpeg format
			fileExtention = ".jpg";
			break;
		case 2: // png format
			fileExtention = ".png";
			break;
		case 3: // bmp format
			fileExtention = ".bmp";
			break;
		default:
			fileExtention =  null;
		}
	return fileExtention;
	}
function fxGetFileFormat(path){
	return path.substr(path.lastIndexOf(".")).toLowerCase();
	}
function fxIsValidImageFormat(format){
	var result = false;
	switch(format){
		case ".jpg":
		case ".jpeg":
		case ".bmp":
		case ".png":
			result = true;
			break;
		default:
			result = false;
			break;	
		}
	return result;
	}
function fxGetAverageRating(average){
	return (Math.round(average/10)/2);
	}
function fxGetTimeLeftString(millisec){
	try{
		var delta = new Date(millisec);
		var hours = delta.getUTCHours();
		var minutes = delta.getUTCMinutes();
		var seconds = delta.getUTCSeconds();
		if(hours > 0){
			return hours +":"+ ((minutes<10)?"0"+minutes:minutes) +":"+ ((seconds<10)?"0"+seconds:seconds);
			}
		else{
			return minutes +":"+ ((seconds<10)?"0"+seconds:seconds);
			}
		}
	catch(ex){
		return "00:00";
		}
	}
function fxRandomNumber(min, max){
	return Math.floor(Math.random() * (max - min + 1) + min);
	}
function fxGetTimestamp(){
	var now = new Date();
	return now.getTime();
	}
function urlString(str){
	return str.replace( /\s/g, "+" );
	}
function truncateString(str, length){
	return (str.length<=length)?str:str.substr(0, length)+"...";
	}
function duplicatespacetrim(str){
	return str.replace( /[ \t]+/g, " " );
	}
function rtrim(str){
	return str.replace( /\s*$/, "" );
	}
function ltrim(str){
	return str.replace( /^\s*/, "" );
	}
function trim(s){
 	return (s.toString().replace(/^\s*|\s*$/g,''));
 	}	
function illegaltrim(str){
	return str.replace( /[\/\:\*\?\"\\\<\>\|\'\(\)]/g ,"" );
	}
function cleanString(str){
	str = illegaltrim(str);
	str = trim(str);
	str = duplicatespacetrim(str);
	return str;
	}
var DragDropHandler = {
	Mousedown: false
	, MouseExited: false
	, WindowCreated : false
	, Key: ""
	, Position: { x:0 , y:0 }
	, Reset: function(){
		this.Mousedown = false;
		this.MouseExited = false;
		this.WindowCreated = false;
		this.Key = "";
		this.Position.x = 0;
		this.Position.y = 0;
		}
	};
album03.onMouseDown = function(){
	DragDropHandler.Mousedown = true;
	DragDropHandler.Position.x = system.event.x;
	DragDropHandler.Position.y = system.event.y;
	}
album03.onMouseUp = function(){
	DragDropHandler.Mousedown = false;
	if(!DragDropHandler.MouseExited){
		if(DragDropHandler.WindowCreated){
			var x = MainWindow.hOffset + album03.hOffset;
			var y = MainWindow.vOffset + AlbumFrame.vOffset + album03.vOffset;
			Floater.ItemByKey(DragDropHandler.Key).window.moveTo(x, y, 2);
			Floater.Close(DragDropHandler.Key);
			}
		}
	else{
		Floater.ItemByKey(DragDropHandler.Key).window.opacity = 255;
		}
	DragDropHandler.Reset();
	}
album03.onMouseExit = function(){
	if(DragDropHandler.Mousedown){
		DragDropHandler.MouseExited = true;
		}
	}
album03.onMouseDrag = function(){
	if(!DragDropHandler.Mousedown){
		return;
		}
	if(!DragDropHandler.WindowCreated){
		var currentalbum = Library.CurrentItem();
		DragDropHandler.Key = currentalbum.Id;
		if(!Floater.Exists(currentalbum.Id)){
			var x = system.event.screenX - system.event.x;
			var y = system.event.screenY - system.event.y;
			Floater.Create(currentalbum.Id, x, y);
			Floater.ItemByKey(DragDropHandler.Key).window.opacity = 155;			
			DragDropHandler.WindowCreated = true;
			}
		else{
			Floater.ItemByKey(currentalbum.Id).Focus();
			return;
			}
		}
	Floater.ItemByKey(DragDropHandler.Key).SetPosition( (system.event.screenX-DragDropHandler.Position.x), (system.event.screenY-DragDropHandler.Position.y) );
	}