var Library = {
	SortAfterSearch: false
	, UseCompilation: true
	, CurrentItem: function(){
		return Albums.ItemByIndex(Browser.CurrentIndex);
		}
	, Reverse: function(){
		Albums.Reverse();
		}
	, Build: function(){
		Source.Build();
		this.Sort();
		}
	, Fill: function(){
		Source.Fill();
		this.Sort();
		}
	, Search: function(text, mode){
		if(text.length>=2){
			var result = Albums.Search(text.toLowerCase(), (mode == "artist")?2:1);
			if(result > 0){
				UI.SearchMode = true;
				this.Sort();
				Browser.Reset();
				Browser.ShowAlbumByIndex(0);
				}
			else{
				UI.ShowResultInfo("No Search Result");
				}
			}
		}
	, ShowAlbumsByArtist: function(artist){
		Searchfield.data = artist;
		Searchclose.visible = true;
		this.Search(artist, "artist");
		}
	, FindFirst: function(){
		searchTimer.ticking = false;
		var index = Albums.Search(keySearch.toLowerCase(), 3);
		if(index == null){
			UI.ShowResultInfo('No Album found: \"' + keySearch + '\"');
			}
		else{
			if(Browser.CurrentIndex != index){
				Browser.ShowAlbumByIndex(index);
				}
			}
		keySearch = "";
		}
	, CloseSearch: function(){
		Albums.RestoreData(this.SortAfterSearch);
		if(this.SortAfterSearch){
			this.Sort();
			this.SortAfterSearch = false;
			}
		}
	, ImportAlbum: function(key, artist, title){
		var result = false;
		try{
			var albumTracks = Player.Search(title);
			if(albumTracks != null){
				UI.ShowResultInfo("Importing New Album...");
				var newAlbum = new Album(key, title, artist);
				var albumCount = albumTracks.Count;
				for(var k = 1; k <= albumCount; k++){
					var track = albumTracks.Item(k);
					if(trim(track.Album) == title){
						if((!track.Compilation)?(trim(track.Artist) == artist):(true)){
							newAlbum.AddTrack(track);
							}
						}
					track = null;
					}
				if(newAlbum.TrackCount > 0){
					Albums.Insert(newAlbum);
					if(!UI.SearchMode){
						this.Sort();
						Browser.Reset();
						}
					result = true;
					}
				else{
					UI.ShowResultInfo("Importing: No tracks found");
					}
				newAlbum = null;
				}
			else{
				UI.ShowResultInfo("Importing: Album not found");
				}
			}
		catch(ex){
			log( "__Error importing album: " + ex );
			}
		return result;
		}
	, RefreshAlbum: function(key){
		try{
			var currentalbum = Albums.GetAlbum(key);
			if(currentalbum != null){
				var artist = currentalbum.Artist;
				var title = currentalbum.Title;
				var albumTracks = Player.Search(title);
				if(albumTracks != null){
					UI.ShowResultInfo("Refreshing Album...");
					var newAlbum = new Album(key, title, artist);
					var isCompilationAlbum = false;
					var albumCount = albumTracks.Count;
					for(var k = 1; k <= albumCount; k++){
						var track = albumTracks.Item(k);
						if(trim(track.Album) == title){
							var isVideo = fxIsVideo(track);
							if( isVideo || (!Library.UseCompilation && track.Compilation) ){
								track = null;
								continue;
								}
							if( (!track.Compilation)?(trim(track.Artist) == artist):true ){
								newAlbum.AddTrack(track);
								}
							if(track.Compilation && !isCompilationAlbum){
								isCompilationAlbum = true;
								}
							}
						track = null;
						}
					if(newAlbum.TrackCount > 0){
						if(isCompilationAlbum){
							newAlbum.Id = fxGenerateAlbumId(artist, title, isCompilationAlbum);
							newAlbum.Artist = Const.CompilationAlbum;
							}
						Albums.Update(key, newAlbum);
						this.Sort();
						Browser.Reset();
						Browser.ResetAlbums();
						Browser.ShowAlbumByKey(newAlbum.Id);
						if(key == UI.ArtworkAlbumKey){
							UI.ShowArtworkWindow(newAlbum.Id);
							}
						if(Floater.Exists(newAlbum.Id)){
							Floater.Update(newAlbum.Id);
							}
						}
					else{
						UI.ShowResultInfo("Refresh: No tracks found");
						}
					newAlbum = null;
					}
				else{
					UI.ShowResultInfo("Refresh: Album not found");
					}
				}
			currentalbum = null;
			}
		catch(ex){
			print( "__Error refreshing album: " + ex );
			}
		}
	, RemoveAlbum: function(key){
		try{
			var currentIndex = Albums.IndexOf(key);
			var currentalbum = Albums.ItemByIndex(currentIndex);
			if(alert(AlertMsg.RemoveAlbum + "\n\nAlbum: " + currentalbum.Title + "\nArtist:  " + currentalbum.Artist, "Remove", "Cancel") == 2){
				currentalbum = null;
				return;
				}
			UI.ShowResultInfo("Removing Album...");
			if(key == UI.ArtworkAlbumKey){
				UI.CloseArtworkWindow();
				}
			if(Floater.Exists(key)){
				Floater.Close(key);
				}
			if(currentalbum.HasArtwork && currentalbum.ArtworkSource == 1){
				var tmpPath = currentalbum.GetArtworkPath();
				if(filesystem.itemExists(tmpPath)){
					filesystem.moveToRecycleBin(tmpPath);
					}
				tmpPath = currentalbum.GetThumbnailPath();
				if(filesystem.itemExists(tmpPath)){
					filesystem.moveToRecycleBin(tmpPath);
					}
				if(currentalbum.HasReflection){
					tmpPath = currentalbum.GetReflectionPath();
					if(filesystem.itemExists(tmpPath)){
						filesystem.moveToRecycleBin(tmpPath);
						}
					}
				}
			Albums.Remove(key);
			if(UI.SearchMode && Albums.Count() == 0){
				UI.CloseSearch();
				}
			else{
				Browser.Reset();
				Browser.ShowAlbumByIndex( (currentIndex == Albums.Count())? currentIndex-1:currentIndex );
				}
			currentalbum = null;
			}
		catch(ex){
			log( "__Error removing album: " + ex );
			}
		}
	, Sort: function(){
		var type = UI.SortMethod;
		var sortFn;
		switch (type){
			case 1:
				if(UI.SortReversed){
					sortFn = function(a, b){
						if(a.Title.toLowerCase() > b.Title.toLowerCase()) return -1;
						if(a.Title.toLowerCase() < b.Title.toLowerCase()) return 1;
						return 0;
						};
					}
				else{
					sortFn = function(a, b){
						if(a.Title.toLowerCase() > b.Title.toLowerCase()) return 1;
						if(a.Title.toLowerCase() < b.Title.toLowerCase()) return -1;
						return 0;
						};
					}
				break; 
			case 2:
				if(UI.SortReversed){
					sortFn = function(a, b){
						if(a.Artist.toLowerCase() + a.Title > b.Artist.toLowerCase() + b.Title) return -1;
						if(a.Artist.toLowerCase() + a.Title < b.Artist.toLowerCase() + b.Title) return 1;	
						return 0;
						};
					}
				else{
					sortFn = function(a, b){
						if(a.Artist.toLowerCase() + a.Title > b.Artist.toLowerCase() + b.Title) return 1;
						if(a.Artist.toLowerCase() + a.Title < b.Artist.toLowerCase() + b.Title) return -1;	
						return 0;
						};
					}
				break; 
			case 3:
				if(UI.SortReversed){
					sortFn = function(a, b){
						if(a.Artist.toLowerCase() + a.Year > b.Artist.toLowerCase() + b.Year) return -1;
						if(a.Artist.toLowerCase() + a.Year < b.Artist.toLowerCase() + b.Year) return 1;
						return 0;
						};
					}
				else{
					sortFn = function(a, b){
						if(a.Artist.toLowerCase() + a.Year > b.Artist.toLowerCase() + b.Year) return 1;
						if(a.Artist.toLowerCase() + a.Year < b.Artist.toLowerCase() + b.Year) return -1;
						return 0;
						};
					}
				break; 
			case 4:
				if(UI.SortReversed){
					sortFn = function(a, b){ return a.Year - b.Year; };
					}
				else{
					sortFn = function(a, b){ return b.Year - a.Year; };
					}
				break; 
			case 5:
				if(UI.SortReversed){
					sortFn = function (a, b){
						if(b.AverageRating == a.AverageRating) return a.TrackCount - b.TrackCount;
						return a.AverageRating - b.AverageRating;
						};
					}
				else{
					sortFn = function (a, b){
						if(b.AverageRating == a.AverageRating) return b.TrackCount - a.TrackCount;
						return b.AverageRating - a.AverageRating;
						};
					}
				break;
			case 6:
				sortFn = function (a, b){
					return (Math.round(Math.random())-0.5);
					}
				break;
			case 7:
				if(UI.SortReversed){
					sortFn = function(a, b){
						if(a.DateAdded.valueOf() == b.DateAdded.valueOf()) return a.Year - b.Year;
						return a.DateAdded.valueOf() - b.DateAdded.valueOf(); 
						};
					}
				else{
					sortFn = function(a, b){
						if(b.DateAdded.valueOf() == a.DateAdded.valueOf()) return b.Year - a.Year;
						return b.DateAdded.valueOf() - a.DateAdded.valueOf(); 
						};
					}
				break;
			}	
		Albums.Sort(sortFn);
		var image = "Resources/sortby" + type + ".png";
		SortbyButton.SetNormalImage(image);
		SortbyButton.SetActiveImage(image);
		}
	};