var TrackDisplay = {
	Field: TrackInfofield
	, TimeField: TrackInfoTimefield
	, TrackKind: ""
	, TimeType: "2"
	, _Timer: new Timer()
	, Info: null
	, HasData: false
	, Started: false
	, Reset: function(){
		this.TrackKind = "";
		if(this.Info!= null){
			this.Info = null;
			this.HasData = false;
			}
		this.SetTooltip("");
		}
	, StartTimer: function(){
		if(!this._Timer.ticking){
			this._Timer.ticking = true;
			this._Timer.onTimerFired = "TrackDisplay.Switch();";
			this._Timer.interval = 1;
			}
		else{
			this._Timer.reset();
			}
		this.Started = true;
		}
	, StopTimer: function(){
		this._Timer.ticking = false;
		this.Started = false;
		}
	, FadeIn: function(){
		var fade = new Array();
		fade.push( new FadeAnimation(this.Field		, 255, 600, animator.kEaseOut ) );
		fade.push( new FadeAnimation(this.TimeField	, 255, 600, animator.kEaseOut ) );
		animator.runUntilDone( fade );
		TrackInfoPlus.opacity = 255;
		}
	, FadeOut: function(){
		TrackInfoPlus.opacity = 128;
		var fade = new Array();
		fade.push( new FadeAnimation(this.Field		, 0, 400, animator.kEaseOut ) );
		fade.push( new FadeAnimation(this.TimeField	, 0, 400, animator.kEaseOut ) );
		animator.runUntilDone( fade );
		}
	, Set: function(track){
		this.Info = null;
		if(this.TrackKind == "url track"){
			this.Info = new StreamInfo();
			this.Info.Set(track.Name, track.Album, track.Artist);
			}
		else{
			this.Info = new TrackInfo();
			this.Info.Set(track.Name, track.Album, track.Artist, track.Time, track.Rating, track.PlayedCount, !!track.Podcast, fxIsVideo(track) );
			}
		this.SetTooltip( this.Info.GetTooltip() );
		this.HasData = true;
		}
	, SetTime: function(text){
		this.TimeField.data = text;
		}
	, SetText: function(text){
		this.Field.data = text;
		}
	, SetTooltip: function(tip){
		TrackInfobg.tooltip = tip;
		}
	, SetTimeType: function(type){
		this.TimeType = type;
		}
	, GetTimeType: function(){
		return this.TimeType;
		}
	, Switch: function(){
		try{
			this.Info.Switch();
			}
		catch(ex){
			}
		}
	, Change: function(track){
		this.TrackKind = Player.Track.Kind;
		this.Set(track);
		this.FadeIn();
		this.StartTimer();
		}
	, Refresh: function(fade){
		if(fade){ this.FadeOut(); }
		this.Change(iTunesObj.CurrentTrack);
		}
	, Clear: function(){		
		this.StopTimer();
		this.FadeOut();
		this.Reset();
		}
	, Stop: function(){
		this.StopTimer();
		}
	, DropdownMenuHandler: function(){
		if( this.HasData && Player.IsPlayingOrPaused() ){
			var items = new Array();
			var item;
			var type = 0;
			var artist, album, track;
			if(this.TrackKind == "url track"){
				switch(this.Info.StreamType){
					case 1:
						type = 2; break;
					case 2:
						type = 1; break;
					case 3:
						type = 1; break;
					}
				}
			else{
				artist = this.Info.Artist;
				album = this.Info.Album;
				track = this.Info.Name;
				type = 3;
				}
			artist = this.Info.Artist;
			album = this.Info.Album;
			track = this.Info.Name;
			var hasArtist = (artist.length > 0);
			var hasAlbum = (album.length > 0);
			var hasTrack = (track.length > 0);
			switch(type){
				case 1:
					if(hasTrack && hasArtist){
						items.push( getMenuHeader("Now Playing:") );
						items.push( getMenuHeader("  " + truncateString(track, 30) ) );
						items.push( getMenuHeader("  " + truncateString(artist, 30) ) );
						if(preferences.TrackDisplayPandoraLinks.value == 1 || preferences.TrackDisplayLastfmLinks.value == 1 || preferences.TrackDisplayVideoSearch.value == 1){
							items.push( getMenuSeparator() );
							if(preferences.TrackDisplayPandoraLinks.value == 1){
								item = getMenuItem( "Pandora", "", true );
								item.appendChild( getMenuItem( "Listen to Song Radio", "fxServicesPandora('song', \""+ track +"\");", true ) );
								item.appendChild( getMenuItem( "Listen to Artist Radio", "fxServicesPandora('artist', \""+ artist +"\");", true ) );
								items.push(item);
								}
							if(preferences.TrackDisplayLastfmLinks.value == 1){
								item = getMenuItem( "Last.fm", "", true );
								item.appendChild( getMenuItem( "Show Similar Artists", "fxServicesLastfm('similar',\""+ artist +"\");", true ) );
								item.appendChild( getMenuItem( "Show Artist", "fxServicesLastfm('artist',\""+artist +"\");", true ) );
								items.push(item);
								}
							if(preferences.TrackDisplayVideoSearch.value == 1){
								item = getMenuItem( "Video Search", "", true );
								item.appendChild( getMenuItem( "Google Video"	, "fxVideoSearch('google'	,\""+ artist +"\", \""+ track +"\");", true ) );
								item.appendChild( getMenuItem( "Yahoo! Video"	, "fxVideoSearch('yahoo'	,\""+ artist +"\", \""+ track +"\");", true ) );
								item.appendChild( getMenuItem( "YouTube"		, "fxVideoSearch('youtube'	,\""+ artist +"\", \""+ track +"\");", true ) );
								items.push(item);
								}
							}
						if(preferences.iTMSArtistSearch.value == 1){
							items.push( getMenuSeparator() );
							item = getMenuItem( "iTunes Store", "", true );
							item.appendChild( getMenuItem( "Show Artist", "Player.ShowArtist(\""+ artist +"\");", true ) );
							items.push(item);
							}
						}
					else{
						items.push( getMenuHeader("Now Playing:") );
						items.push( getMenuHeader("  " + this.Info.Station) );
						if(this.Info.StationUrl != ""){
							items.push( getMenuItem( "  " + this.Info.StationUrl, "openURL('"+ this.Info.StationUrl +"');", true ) );
							}
						}
					break;
				case 2:
				case 3:
					if(hasTrack && hasArtist){
						items.push( getMenuHeader("Now Playing:") );
						items.push( getMenuHeader("  " + truncateString(track, 30) ) );
						if(hasAlbum){  items.push( getMenuHeader("  " + truncateString(album, 30) ) ); }
						items.push( getMenuHeader("  " + truncateString(artist, 30)) );
						if(Player.IsPlaying() && this.TrackKind == "file track"){
							items.push( getMenuSeparator() );
							items = items.concat( getRatingMenuItems(Player.Track.Rating) );
							if(preferences.TrackDisplayAddToPlaylist.value == 1){
								var showPartyShuffle = (iTunesObj.CurrentPlaylist.SpecialKind != 2);
								var pname = preferences.PlaylistFavoriteName.value;
								var showFavorites = (pname != "");
								if(showPartyShuffle || showFavorites){
									items.push( getMenuSeparator() );
									item = getMenuItem( "Add Track to Playlist", "", true );
									if(showPartyShuffle){
										item.appendChild( getMenuItem( "Party Shuffle", "Player.AddCurrentTrackToPlaylist('Party Shuffle');", true ) );
										}
									if(showFavorites){
										item.appendChild( getMenuItem( pname, "Player.AddCurrentTrackToPlaylist('"+ pname +"');", true ) );
										}
									items.push(item);
									}
								}
							}
						var hideLinks = (type == 3)?this.Info.IsPodcastOrVideo:false;
						if(!hideLinks){
							if(preferences.TrackDisplayPandoraLinks.value == 1 || preferences.TrackDisplayLastfmLinks.value == 1 || preferences.TrackDisplayVideoSearch.value == 1){
								items.push( getMenuSeparator() );
								if(preferences.TrackDisplayPandoraLinks.value == 1){
									item = getMenuItem( "Pandora", "", true );
									item.appendChild( getMenuItem( "Listen to Song Radio", "fxServicesPandora('song', \""+ track +"\");", true ) );
									item.appendChild( getMenuItem( "Listen to Artist Radio", "fxServicesPandora('artist', \""+ artist +"\");", true ) );
									items.push(item);
									}
								if(preferences.TrackDisplayLastfmLinks.value == 1){
									item = getMenuItem( "Last.fm", "", true );
									item.appendChild( getMenuItem( "Show Similar Artists", "fxServicesLastfm('similar',\""+ artist +"\");", true ) );
									item.appendChild( getMenuItem( "Show Artist", "fxServicesLastfm('artist',\""+artist +"\");", true ) );
									if(hasAlbum){ item.appendChild( getMenuItem( "Show Album", "fxServicesLastfm('album',\""+ artist +"\",\""+ album +"\");", true ) ); }
									items.push(item);
									}
								if(preferences.TrackDisplayVideoSearch.value == 1){
									item = getMenuItem( "Video Search", "", true );
									item.appendChild( getMenuItem( "YouTube"		, "fxVideoSearch('youtube'	,\""+ artist +"\", \""+ track +"\");", true ) );
									item.appendChild( getMenuItem( "Google Video"	, "fxVideoSearch('google'	,\""+ artist +"\", \""+ track +"\");", true ) );
									item.appendChild( getMenuItem( "Yahoo! Video"	, "fxVideoSearch('yahoo'	,\""+ artist +"\", \""+ track +"\");", true ) );
									items.push(item);
									}
								}
							if(preferences.iTMSArtistSearch.value == 1){
								items.push( getMenuSeparator() );
								item = getMenuItem( "iTunes Store", "", true );
								item.appendChild( getMenuItem( "Show Artist", "Player.ShowArtist(\""+ artist +"\");", true ) );
								if(hasAlbum){ item.appendChild( getMenuItem( "Show Album", "iTunes.ShowAlbum(\""+ artist +"\", \""+ album +"\");", true ) ); }
								items.push(item);
								}
							
							}
						}
					else{
						items.push( getMenuHeader("Now Playing:") );
						items.push( getMenuHeader("  No Information Available") );
						}
					break;
				}
			popupMenu(items, system.event.hOffset, system.event.vOffset);
			}	
		}
	, ChangePlayState: function(){
		 var state = Player.State;
		 switch(state){
			case "playing":
				PlayButton.SetNormalImage("Resources/pausebtn.png");
				PlayButton.SetActiveImage("Resources/pausebtn_active.png");
				break;
			case "stopped":
			case "paused":
				PlayButton.SetNormalImage("Resources/playbtn.png");
				PlayButton.SetActiveImage("Resources/playbtn_active.png");
				break;
			}
		}
	, RefreshTime: function(){
		if(this.HasData){
			this.Info.SetPlayerPosition();
			}
		}
	};
function TrackInfo(){
	this.Name = "";
	this.Album = "";
	this.Artist = "";
	this.Rating = 0;
	this.PlayedCount = 0;
	this.TotalTime = 0;
	this.TotalTimeString = "";
	this.CurrentTime = 0;
	this.Status = 1;
	this.Ticks = 0;
	this.IsPodcastOrVideo = false;
	}
TrackInfo.prototype = {
	Set: function(name, album, artist, time, rating, playedCount, isPodcast, isVideo){
		this.Name = name;
		this.Album = album;
		this.Artist = artist
		this.Rating = fxGetAverageRating(rating);
		this.PlayedCount = playedCount;
		this.TotalTime = Player.Track.Duration;
		this.TotalTimeString = time;
		this.IsPodcastOrVideo = ( isVideo || isPodcast);
		this.SetPlayerPosition();
		this.Show();
		}
	, Switch: function(){
		switch(this.Ticks++){
			case 4:
				this.SetPlayerPosition();
				break;
			case 8:
				this.SetPlayerPosition();
				this.Show();
				this.Ticks = 0;
				break;
			default:
				this.CurrentTime++;
				break;
			}
		TrackDisplay.SetTime(this.GetTime());
		}
	, Show: function(){
		var text;
		switch(this.Status){
			case 1:
				text = this.Name + " - " + this.Artist;
				this.Status = 2;
				break;
			case 2:
				text = this.Name + " - " + this.Album;
				this.Status = 1;
				break;
			}
		TrackDisplay.SetText(text);
		}
	, GetTime: function(){
		switch(TrackDisplay.TimeType){
			case "1":
				return this.TotalTimeString;
				break;
			case "2":
				return fxGetTimeLeftString(Math.max((this.TotalTime - this.CurrentTime), 0) * 1000);
				break;
			case "3":
				return fxGetTimeLeftString(Math.min(this.CurrentTime, this.TotalTime) * 1000);
				break;
			}
		}
	, GetTooltip: function(){
		var tip = "Now Playing:" + this.CheckText(this.Name) + this.CheckText(this.Album) + this.CheckText(this.Artist);
		if(tip == "Now Playing:"){
			tip += "\nNo Information Available";
			}
		if(TrackDisplay.TrackKind == "file track"){
			tip += "\n\nRating: " + this.Rating  + ((this.Rating == 1)?" star":" stars") + "\nPlay Count: " + this.PlayedCount;
			}
		return tip;
		}
	, SetPlayerPosition: function(){
		this.CurrentTime = Player.Position;
		}
	, CheckText: function(value){
		return (value.length > 0)?"\n" + value:"";
		}
	};
function StreamInfo(){
	this.Title = "";
	this.Station = "";
	this.CurrentTime = 0;
	this.Status = 1;
	this.Ticks = 0;
	this.StreamType = 0;
	this.StationUrl = "";
	this.Name = "";
	this.Album = "";
	this.Artist = "";
	}
StreamInfo.prototype = {
	Set: function(name, album, artist){
		if(artist !="" && album != "" && name != ""){
			this.StreamType = 1;
			this.Title = name + " - " + album;
			this.Station = name + " - " + artist;
			this.Name = name;
			this.Album = album;
			this.Artist = artist;
			}
		else{
			if(Player.Track.StreamTitle != ""){
				this.StreamType = 2;
				this.Title = Player.Track.StreamTitle;
				this.Station = Player.Track.Name;
				var check = new RegExp("( - )", "g");
				if( check.test(this.Title) ){
					try{
						var data = this.Title.split(" - ");
						this.Artist = data[0];
						this.Name = data[data.length - 1];
						}
					catch(ex){
						log("__Error getting info from stream: " + ex);
						}
					}
				check = null;
				}
			else{
				this.StreamType = 3;
				this.Title = this.Station = Player.Track.Name;
				}
			this.StationUrl = Player.Track.StreamURL;
			}
		this.SetPlayerPosition();
		this.Show();
		}
	, Switch: function(){
		this.Ticks++
		if(this.Ticks == 4){
			this.SetPlayerPosition();
			this.Show();
			this.Ticks = 0;
			}
		else{
			this.CurrentTime++;
			}
		TrackDisplay.SetTime(this.GetTime());
		}
	, Show: function(){
		var text;
		switch(this.Status){
			case 1:
				text = this.Title;
				this.Status = 2;
				break;
			case 2:
				text = this.Station;
				this.Status = 1;
				break;
			}
		TrackDisplay.SetText(text);
		}
	, GetTime: function(){
		return fxGetTimeLeftString(this.CurrentTime * 1000);
		}
	, GetTooltip: function(){
		switch(this.StreamType){
			case 1:
				return "Now Playing:\n" + this.Name + "\n" + this.Album + "\n" + this.Artist;
				break;
			case 2:
				if(this.Name != "" && this.Artist != ""){
					return "Now Playing:\n" + this.Name + "\n" + this.Artist + "\n\n" + this.Station + this.CheckText(this.StationUrl);
					}
				else{
					return "Now Playing:\n" + this.Title + "\n\n" + this.Station + this.CheckText(this.StationUrl);
					}
				break;
			case 3:
				return "Now Playing:\n" + this.Station + this.CheckText(this.StationUrl);
				break;
			}
		}
	, SetPlayerPosition: function(){
		this.CurrentTime = Player.Position;
		}
	, CheckText: function(value){
		return (value.length > 0)?"\n" + value:"";
		}
	};