var UI={
	SortMethod: 2
	, HasFocus: false
	, Busy: false
	, SearchMode: false
	, SortReversed: false
	, AutoScroll: false
	, Tooltip: false
	, MiniPopup: false
	, DockVitality: false
	, OverrideMiniPopup: false
	, TrackDisplay: false
	, AutoImport: false
	, AlbumReflection: true
	, currentProgress: 0
	, ArtworkAlbumKey: null
	, Minimized: false
	, Iconized: false
	, SnapToTop: false
	, Topmost: false
	, Focus: function(){
		if(this.Iconized){
			IconWindow.focus();
			}
		else{
			MainWindow.focus();
			}
		}
	, Iconize: function(){
		if(this.Iconized){
			if(Widget.Sleeping){ Widget.WakeUp(); }
			fxInitTrackDisplay();
			IconWindow.visible = false;
			MainWindow.visible = true;
			this.Iconized = false;
			if(this.ArtworkAlbumKey != null){
				ArtworkWindow.visible = true;
				}
			}
		else{
			if(ArtworkWindow.visible){
				ArtworkWindow.visible = false;
				}
			MainWindow.visible = false;
			IconWindow.visible = true;
			this.Iconized = true;
			TrackDisplay.Clear();
			IconImage.tooltip = fxGetIconTooltip();
			}
		}
	, Minimize: function(){
		if(this.Iconized){
			return;
			}
		if(this.Minimized){
			Background.visible = true;
			Menubar.visible = true;
			AlbumFrame.visible = true;
			Previousbtn.visible = true;
			Nextbtn.visible = true;
			Firstbtn.visible = true;
			Lastbtn.visible = true;
			Sliderbg.visible = true;
			Sliderbtn.visible = true;
			Sliderfield.visible = true;
			Sortbytext.visible = true;
			Sortby.visible = true;
			TotalAlbumsfield.visible = true;
			Ratingstars.visible = true;
			AlbumdataFrame.visible = true;
			Preferencesbtn.visible = true;
			Albumoptionbtn.visible = true;
			this.Minimized = false;
			MinimizeButton.SetNormalImage("Resources/minimizebtn.png");
			MinimizeButton.SetActiveImage("Resources/minimizebtn.png");
			if(this.AutoScroll){
				AutoScrollfield.visible = true;
				if( Player.IsRunning() ){
					if( Player.IsPlaying() ){
						if(!this.SearchMode){
							var track = iTunesObj.CurrentTrack;
							if(track != null){
								if(track.Kind == 1){
									var key = fxGenerateAlbumId(track.Artist, track.Album, track.Compilation);
									if(Albums.Exists(key)){
										Browser.ShowAlbumByKey(key);
										}
									}
								}
							}
						}
					}
				}
			if(this.Tooltip){
				Minimizebtn.tooltip = "Minimize";
				}
			}
		else{
			Background.visible = false;
			Menubar.visible = false;
			AlbumFrame.visible = false;
			Previousbtn.visible = false;
			Nextbtn.visible = false;
			Firstbtn.visible = false;
			Lastbtn.visible = false;
			Sliderbg.visible = false;
			Sliderbtn.visible = false;
			Sliderfield.visible = false;
			Sortbytext.visible = false;
			Sortby.visible = false;
			TotalAlbumsfield.visible = false;
			Ratingstars.visible = false;
			AlbumdataFrame.visible = false;
			AutoScrollfield.visible = false;
			Preferencesbtn.visible = false;
			Albumoptionbtn.visible = false;
			if(ResultInfoFrame.visible){
				ResultInfoTimer.ticking = false;
				ResultInfoFrame.visible = false;
				ResultInfofield.data = "";
				}
			this.Minimized = true;
			MinimizeButton.SetNormalImage("Resources/maximizebtn.png");
			MinimizeButton.SetActiveImage("Resources/maximizebtn.png");
			if(this.Tooltip){
				Minimizebtn.tooltip = "Maximize";
				}
			}
		MainWindow.recalcShadow();
		}
	, ShowIndexFrame: function(show, header){
		if(show){
			this.Busy = true;
			Headerfield.data = header;
			if(this.AutoScroll){ AutoScrollfield.visible = false; }
			suppressUpdates();
			}
		else{
			if(this.AutoScroll){ AutoScrollfield.visible = true; }
			resumeUpdates();
			this.Busy = false;
			Progressfield.data = "";
			Headerfield.data = "";
			}
		indexFrame.visible = show;
		}
	, UpdateIndexFrame: function(progress, timeleft){
		if( this.currentProgress != progress ){
			Progressfield.data = progress + "% completed";
			TimeleftField.data = "Estimated time remaining: " + fxGetTimeLeftString(timeleft);
			updateNow();
			this.currentProgress = progress;
			}
		}
	, ChangeSortMethod: function(method){
		if(this.SortMethod != method){
			this.SortMethod = method;
			Library.Sort();
			if(this.SearchMode){ Library.SortAfterSearch = true; }
			if(this.Minimized){
				this.Minimize();
				}
			Browser.EndArtwork();
			Browser.StartArtwork();
			preferences.SortMethod.value = method;
			savePreferences();
			}
		}
	, ReverseSortOrder: function(){
		this.SetSortReversed(!UI.SortReversed);
		Library.Reverse();
		if(this.SearchMode){ Library.SortAfterSearch = true; }
		if(this.Minimized){ this.Minimize(); }
		Browser.EndArtwork();
		Browser.StartArtwork();
		preferences.SortReversed.value = ( UI.SortReversed? "1":"0" );
		savePreferences();
		}
	, SetDockVitality: function(value){
		this.DockVitality = value;
		if(this.DockVitality){
			Player.DockPlayingTrack();
			}
		else{
			Widget.SetDockInfo(Const.DockImage, null);
			}
		}
	, SetAlbumReflection: function(value){
		this.AlbumReflection = value;
		if(this.AlbumReflection){
			reflection01.visible = true;
			reflection02.visible = true;
			reflection03.visible = true;
			reflection04.visible = true;
			reflection05.visible = true;
			Browser.SetAlbum(Browser.CurrentIndex);
			}
		else{
			reflection01.visible = false;
			reflection02.visible = false;
			reflection03.visible = false;
			reflection04.visible = false;
			reflection05.visible = false;
			reflection01.src = "";
			reflection02.src = "";
			reflection03.src = "";
			reflection04.src = "";
			reflection05.src = "";
			}
		}
	, SetAutoScroll: function(value){
		if(!this.Minimized){
			AutoScrollfield.visible = value;
			}
		this.AutoScroll = value;
		}
	, SetHotKeys: function(enable){
		fxSetHotkey( hotkeyCurrentAlbum, enable, preferences.HotkeyCurrentAlbum.value, "UI.HotkeyHandler('ShowPlayingAlbum');" );
		fxSetHotkey( hotkeyCurrentTrack, enable, preferences.HotkeyCurrentTrack.value, "UI.HotkeyHandler('ShowPlayingTrack');" );
		fxSetHotkey( hotkeyRandomAlbum, enable, preferences.HotkeyRandomAlbum.value, "UI.HotkeyHandler('ShowRandomAlbum');" );
		fxSetHotkey( hotkeyFocusWidget, enable, preferences.HotkeyFocusWidget.value, "UI.HotkeyHandler('FocusWidget');" );
		fxSetHotkey( hotkeyMinimize, enable, preferences.HotkeyMinimize.value, "UI.HotkeyHandler('Minimize');" );
		fxSetHotkey( hotkeyToggle, enable, preferences.HotkeyToggle.value, "UI.HotkeyHandler('Toggle');" );
		}
	, SetSortReversed: function(value){
		this.SortReversed = value;
		if(this.SortReversed){
			Firstbtn.src = "Resources/sliderlast.png";
			Lastbtn.src = "Resources/sliderfirst.png";
			}
		else{
			Firstbtn.src = "Resources/sliderfirst.png";
			Lastbtn.src = "Resources/sliderlast.png";
			}
		}
	, SetTooltip: function(value){
		if(this.Tooltip != value){
			this.Tooltip = value;
			if(this.Tooltip){
				Previousbtn.tooltip = "Previous Album (click and hold to browse)";
				Nextbtn.tooltip = "Next Album (click and hold to browse)";
				Firstbtn.tooltip = "First Album";
				Lastbtn.tooltip = "Last Album";
				ArtworkImage.tooltip = "Right click for options";
				CloseArtbtn.tooltip = "Close Artwork window";
				Searchfield.tooltip = "Search for artists and albums";
				Searchbg.tooltip = "Search for artists and albums";
				Searchclose.tooltip = "Close search results";
				album03.tooltip = "Double click to execute default album action\nRight click for options\nScroll mouse wheel to browse\nClick and drag to create a album window";
				Closebtn.tooltip = "Close to icon size";
				Minimizebtn.tooltip = (this.Minimized)?"Maximize":"Minimize";
				Backwardbtn.tooltip = "Previous Track (click and hold to Rewind)";
				Playbtn.tooltip = "Play/Pause";
				Forwardbtn.tooltip = "Next Track (click and hold to Fast Forward)";
				TrackInfoPlus.tooltip = "Click for options";
				Preferencesbtn.tooltip = "Widget Preferences...";
				Albumoptionbtn.tooltip = "Album options";
				Volumedownbtn.tooltip = "Volume Down";
				Volumeupbtn.tooltip = "Volume Up";
				iTunesoptionbtn.tooltip = "Click for iTunes options";
				}
			else{
				Previousbtn.tooltip = "";
				Nextbtn.tooltip = "";
				Firstbtn.tooltip = "";
				Lastbtn.tooltip = "";
				ArtworkImage.tooltip = "";
				CloseArtbtn.tooltip = "";
				Searchfield.tooltip = "";
				Searchbg.tooltip = "";
				Searchclose.tooltip = "";
				album03.tooltip = "";
				Closebtn.tooltip = "";
				Minimizebtn.tooltip = "";
				Backwardbtn.tooltip = "";
				Playbtn.tooltip = "";
				Forwardbtn.tooltip = "";
				TrackInfoPlus.tooltip = "";
				Preferencesbtn.tooltip = "";
				Albumoptionbtn.tooltip = "";
				Volumedownbtn.tooltip = "";
				Volumeupbtn.tooltip = "";
				iTunesoptionbtn.tooltip = "";
				}
			}
		}
	, SetDefaultArtwork: function(color, refresh){
		Const.NoArtworkImage = "Resources/noartwork_"+ color +".png";
		Const.NoReflectionImage = "Resources/noreflection_"+ color +".png";
		if(refresh){
			Browser.ResetAlbums();
			Browser.SetAlbum(Browser.CurrentIndex);
			if(ArtworkWindow.visible){
				this.ShowArtworkWindow(this.ArtworkAlbumKey);
				}
			}
		}
	, ContextMenuHandler: function(origin){
		var items = new Array();
		var iTunesIsRunning = Player.IsRunning();
		var searchMode = this.SearchMode;
		switch(origin){
			case "widget":
				if(iTunesIsRunning){
					items.push( getMenuItem("Show Current Album", "Player.DisplayPlayingAlbum();", ( Player.IsPlaying() && !Player.Track.IsStream) ) );
					if(UI.MiniPopup && !UI.Busy){
						items.push( getMenuItem("Show Current Track", "Player.DisplayPlayingTrack();", Player.IsPlaying() ) );
						}
					items.push( getMenuItem("Show Random Album", "Browser.ShowRandomAlbum();", true ) );
					}
				else{
					items.push( getMenuItem("Show Random Album", "Browser.ShowRandomAlbum();", true ) );
					items.push( getMenuSeparator() );
					items.push( getMenuItem("Launch iTunes", "Player.RunApplication(true);", true) );
					}
				items.push( getMenuSeparator() );
				items.push( getCheckMenuItem("Snap To Top", "UI.SetSnapToTop()", UI.SnapToTop, true) );
				items.push( getCheckMenuItem("Always On Top", "UI.SetTopmost()", UI.Topmost, true) );
				items.push( getMenuSeparator() );
				items.push( getMenuItem("Help", "filesystem.open('"+ Const.HelpFile + "');", true) );
				items.push( getMenuSeparator() );
				items.push( getMenuItem("Reindex iTunes Music Library", "Widget.RebuildLibrary();", iTunesIsRunning && !searchMode) );
				items.push( getMenuItem("Locate Artwork Folder on Disk", "UI.DiplayCoverFolder();", true) );
				if(ArtworkWindow.visible){
					items.push( getMenuItem("Close Artwork Window", "UI.CloseArtworkWindow();", true) );
					}
				if(Floater.Count()>0){
					items.push( getMenuItem("Close All Album Windows", "Floater.CloseAll();", true) );
					}
				items.push( getMenuItem("Reload Widget", "reloadWidget();", true) );
				MainWindow.contextMenuItems = items;
				break;
			case "album":
				var currentalbum = Library.CurrentItem();
				items.push( getMenuItem("Play Album", "Player.PlayAlbum('"+ currentalbum.Id +"');", iTunesIsRunning) );
				items.push( getMenuItem("Add Album to Playlist", "Player.AddAlbum('"+ currentalbum.Id +"');", iTunesIsRunning) );
				items.push( getMenuItem("Show Artwork...", "UI.ShowArtworkWindow('"+ currentalbum.Id +"');", true) );
				items.push( getMenuSeparator() );
				items.push( getMenuItem("Show All Albums by Artist", "Library.ShowAlbumsByArtist(\""+ currentalbum.Artist +"\");", true) );
				items.push( getMenuSeparator() );
				items.push( getMenuItem("Refresh Album", "Library.RefreshAlbum('"+ currentalbum.Id +"');", iTunesIsRunning) );
				items.push( getMenuItem("Remove Album", "Library.RemoveAlbum('"+ currentalbum.Id +"');", true) );
				items.push( getMenuSeparator() );
				items.push( getMenuItem("Create Album Window...", "Floater.Add('"+ currentalbum.Id +"');", true) );
				items.push( getMenuSeparator() );
				if(iTunesIsRunning && preferences.iTMSArtistSearch.value == 1){
					var item = getMenuItem( "iTunes Store", "", true );
					item.appendChild( getMenuItem( "  Show Artist", "Player.ShowArtist(\""+ currentalbum.Artist +"\");", true ) );
					item.appendChild( getMenuItem( "  Show Album", "Player.ShowAlbum(\""+ currentalbum.Artist +"\", \""+ currentalbum.Title +"\");", true ) );
					items.push(item);
					items.push( getMenuSeparator() );
					}
				currentalbum = null;
				album03.contextMenuItems = items;
				break;
			case "artwork":
				var currentalbum = Albums.GetAlbum(UI.ArtworkAlbumKey);
				if(iTunesIsRunning){
					items.push( getMenuItem("Add Artwork to Album...", "Player.AddAlbumArtwork('"+ currentalbum.Id +"', 'manual');", currentalbum.ArtworkSource != 1 ) );
					items.push( getMenuItem("Delete Artwork from Album", "Player.DeleteAlbumArtwork('"+ currentalbum.Id +"');", currentalbum.ArtworkSource == 1) );
					items.push( getMenuSeparator() );
					}
				var item;
				item = getMenuItem( "Search for Artwork", "", true );
				item.appendChild( getMenuItem("Google Images"		, "fxArtworkImageSearch('google');", true) );
				item.appendChild( getMenuItem("Windows Live"		, "fxArtworkImageSearch('windowslive');", true) );
				item.appendChild( getMenuItem("Yahoo! Image Search"	, "fxArtworkImageSearch('yahoo');", true) );
				items.push(item);
				item = getMenuItem( "Visit other Artwork sites", "", true );
				item.appendChild( getMenuItem("Albumart.org" , "openURL('http://www.albumart.org');", true) );
				item.appendChild( getMenuItem("Slothradio CD Cover Search" , "openURL('http://www.slothradio.com/covers/');", true) );
				item.appendChild( getMenuItem("Find My Cover" , "openURL('http://www.findmycover.com');", true) );
				items.push(item);
				items.push( getMenuSeparator() );
				items.push( getMenuItem("Close Artwork Window", "UI.CloseArtworkWindow();", true) );
				items.push( getMenuItem("Locate Artwork Image on Disk", "UI.DiplayArtworkImage();", currentalbum.HasArtwork) );
				items.push( getMenuItem("Create Album Window...", "Floater.Add('"+ currentalbum.Id +"');", true) );
				currentalbum = null;
				ArtworkWindow.contextMenuItems = items;
				break;
			case "minipopup":
				if(Player.IsPlaying() && !UI.Busy){
					var type = Player.Track.Kind;
					if(type == "file track" || type == "cd track"){
						items.push( getMenuItem("Pause", "Player.Pause();", true) );
						items.push( getMenuItem("Next Song", "Player.NextTrack();", true) );
						items.push( getMenuItem("Previous Song", "Player.BackTrack();", true) );
						if(type == "file track"){
							items.push( getMenuSeparator() );
							items = items.concat( getRatingMenuItems(Player.Track.Rating) );
							}
						MiniPopupWindow.contextMenuItems = items;	
						MiniPopupTimer.reset();
						}
					}
				break;
			case "icon":
				items.push( getMenuItem("Open Widget", "UI.Iconize();", true) );
				if(Widget.Sleeping){
					items.push( getMenuItem("Wake Up Widget", "Widget.WakeUp();", true) );
					}
				else{
					items.push( getMenuItem("Hibernate Widget", "Widget.Hibernate();", true) );
					}
				items.push( getMenuItem("Reload Widget", "reloadWidget();", true) );
				if(Floater.Count() > 0){
					items.push( getMenuSeparator() );
					items.push( getMenuItem("Close All Album Windows", "Floater.CloseAll();", true) );
					}
				IconWindow.contextMenuItems = items;
				break;
			}
		items = null;
		}
	, DropdownMenuHandler: function(origin){
		switch(origin){
			case "sortby":
				popupMenu(getSortByMenuItems(), Sortby.hOffset + 6, Sortby.vOffset - 113);
				break;
			case "itunes":
				var items = new Array();
				if(Player.IsRunning()){
					items.push( getMenuItem("Show iTunes", "Player.Focus();", true) );
					var active = false;
					if(Player.IsPlayingOrPaused()){
						if(Player.Track.IsStream){
							active = false;
							}
						else{
							active = true;
							}
						}
					var repeat = Player.Playlist.Repeat;
					items.push( getMenuSeparator() );
					items.push( getCheckMenuItem( "Repeat Off" , "Player.Playlist.Repeat = 'off'", (repeat == "off"), active) );
					items.push( getCheckMenuItem( "Repeat All" , "Player.Playlist.Repeat = 'all'", (repeat == "all"), active) );
					items.push( getCheckMenuItem( "Repeat One" , "Player.Playlist.Repeat = 'one'", (repeat == "one"), active) );
					items.push( getMenuSeparator() );
					items.push( getCheckMenuItem( "Shuffle" , "Player.Playlist.Shuffle = !Player.Playlist.Shuffle", Player.Playlist.Shuffle , active) );
					if(preferences.PlaylistSelection.value == 1){
						items.push( getMenuSeparator() );
						items.push( getPlaylistMenuItems() );
						}
					items.push( getMenuSeparator() );
					items.push( getMenuItem("Open iTunes Store", "Player.ShowMusicStore();", true) );
					if(preferences.iTMSJustForYou.value == 1){
						items.push( getMenuItem("Open Just For You", "Player.ShowMusicStoreFeature('JustForYou');", true) );
						}
					if(preferences.iTMSMovies.value == 1){
						items.push( getMenuItem("Open Movie Trailers", "Player.ShowMusicStoreFeature('MovieTrailers');", true) );
						}
					if(preferences.iTMSTopSongs.value == 1){
						items.push( getMenuItem("Open Today\'s Top Songs", "Player.ShowMusicStoreFeature('TopSongs');", true) );
						}
					if(preferences.iTMSTopAlbums.value == 1){
						items.push( getMenuItem("Open Today\'s Top Albums", "Player.ShowMusicStoreFeature('TopAlbums');", true) );
						}
					items.push( getMenuSeparator() );
					items.push( getMenuItem("Quit iTunes", "Player.Quit();", true) );
					}
				else{
					items.push( getMenuItem("Launch iTunes", "Player.RunApplication(true);", true) );
					}
				popupMenu(items, system.event.hOffset, system.event.vOffset);
				break;
			case "album":
				var items = new Array();
				var iTunesIsRunning = Player.IsRunning();
				var currentalbum = Library.CurrentItem();
				items.push( getMenuHeader( truncateString(currentalbum.Artist, 30) ) );
				items.push( getMenuHeader( truncateString(currentalbum.Title, 30) ) );
				items.push( getMenuSeparator() );
				items.push( getMenuItem("Play Album", "Player.PlayAlbum('"+ currentalbum.Id +"');", iTunesIsRunning) );
				items.push( getMenuItem("Add Album to Playlist", "Player.AddAlbum('"+ currentalbum.Id +"');", iTunesIsRunning) );
				items.push( getMenuItem("Show Artwork...", "UI.ShowArtworkWindow('"+ currentalbum.Id +"');", true) );
				items.push( getMenuSeparator() );
				items.push( getMenuItem("Show All Albums by Artist", "Library.ShowAlbumsByArtist(\""+ currentalbum.Artist +"\");", true) );
				items.push( getMenuSeparator() );
				items.push( getMenuItem("Refresh Album", "Library.RefreshAlbum('"+ currentalbum.Id +"');", iTunesIsRunning) );
				items.push( getMenuItem("Remove Album", "Library.RemoveAlbum('"+ currentalbum.Id +"');", true) );
				items.push( getMenuSeparator() );
				items.push( getMenuItem("Create Album Window...", "Floater.Add('"+ currentalbum.Id +"');", true) );
				currentalbum = null;
				popupMenu(items, Albumoptionbtn.hOffset + 13, Albumoptionbtn.vOffset - 140);
				break;
			}
		}
	, HotkeyHandler: function(action){
		switch(action){
			case "ShowPlayingAlbum":
				Player.DisplayPlayingAlbum();
				break;
			case "ShowRandomAlbum":
				Browser.ShowRandomAlbum();
				break;
			case "ShowPlayingTrack":
				Player.DisplayPlayingTrack();
				break;
			case "FocusWidget":
				this.Focus();
				break;
			case "Minimize":
				this.Minimize();
				break;
			case "Toggle":
				Player.Toggle();
				break; 
			}
		}
	, AlbumActionHandler: function(){
		var key = Library.CurrentItem().Id;
		switch(preferences.AlbumAction.value){
			case "1":
				Player.PlayAlbum(key);
				break; 
			case "2":
				Player.AddAlbum(key);
				break;
			case "3":
				this.ShowArtworkWindow(key);
				break;
			}
		}
	, ShowResultInfo: function(msg){
		try{
			if(UI.Minimized){
				return;
				}
			if(ResultInfoFrame.visible){
				ResultInfoTimer.reset();
				ResultInfoTimer.ticking = true;
				ResultInfofield.data = msg;
				}
			else{
				ResultInfofield.data = msg;
				ResultInfoFrame.visible = true;
				animator.runUntilDone( new FadeAnimation( ResultInfoFrame, 255, 400, animator.kEaseNone ) );
				ResultInfoTimer.ticking = true;
				}
			}
		catch(ex){
			log("__Error showing ResultInfo:" + ex);
			}
		}
	, CloseResultInfo: function(){
		ResultInfoTimer.ticking = false;
		animator.runUntilDone( new FadeAnimation( ResultInfoFrame, 0, 600, animator.kEaseIn ) );
		ResultInfoFrame.visible = false;
		ResultInfofield.data = "";
		}
	, CloseSearch: function(){
		if(this.SearchMode){
			if(this.Minimized){
				this.Minimize();
				}
			var a = new Array();
			a.push( new FadeAnimation( album01, 0, 200, animator.kEaseOut ) );
			a.push( new FadeAnimation( album02, 0, 200, animator.kEaseOut ) );
			a.push( new FadeAnimation( album04, 0, 200, animator.kEaseOut ) );
			a.push( new FadeAnimation( album05, 0, 200, animator.kEaseOut ) );
			if(this.AlbumReflection){
				a.push( new FadeAnimation( reflection01, 0, 200, animator.kEaseOut ) );
				a.push( new FadeAnimation( reflection02, 0, 200, animator.kEaseOut ) );
				a.push( new FadeAnimation( reflection04, 0, 200, animator.kEaseOut ) );
				a.push( new FadeAnimation( reflection05, 0, 200, animator.kEaseOut ) );
				}
			a.push( new FadeAnimation( TotalAlbumsfield, 0, 200, animator.kEaseOut ) );
			animator.runUntilDone( a );
			a = null;
			if( Albums.Count() > 0 ){
				var key = Library.CurrentItem().Id;
				Library.CloseSearch();
				var index = Albums.IndexOf(key);
				Browser.Reset();
				Browser.ShowAlbumByIndex((index != null)? index: 0);
				}
			else{
				Library.CloseSearch();
				Browser.Reset();
				Browser.ShowAlbumByIndex(0);
				}
			Searchfield.data = "";
			Searchclose.visible = false;
			this.SearchMode = false;
			var b = new Array();
			b.push( new FadeAnimation( album01, 255, 600, animator.kEaseOut ) );
			b.push( new FadeAnimation( album02, 255, 600, animator.kEaseOut ) );
			b.push( new FadeAnimation( album04, 255, 600, animator.kEaseOut ) );
			b.push( new FadeAnimation( album05, 255, 600, animator.kEaseOut ) );
			if(this.AlbumReflection){
				b.push( new FadeAnimation( reflection01, 255, 600, animator.kEaseOut ) );
				b.push( new FadeAnimation( reflection02, 255, 600, animator.kEaseOut ) );
				b.push( new FadeAnimation( reflection04, 255, 600, animator.kEaseOut ) );
				b.push( new FadeAnimation( reflection05, 255, 600, animator.kEaseOut ) );
				}
			b.push( new FadeAnimation( TotalAlbumsfield, 255, 600, animator.kEaseOut ) );
			animator.runUntilDone( b );
			b = null;
			}
		else{
			Searchfield.data = "";
			Searchclose.visible = false;
			Searchfield.loseFocus();
			}
		}
	, ShowArtworkWindow: function(key){
		var currentalbum = Albums.ItemByKey(key);
		if(currentalbum != null){
			this.ArtworkAlbumKey = key;
			ArtworkImage.src = currentalbum.GetArtworkPath();
			var height = Math.min(ArtworkImage.srcHeight, 600);
			var width = Math.min(ArtworkImage.srcWidth, 600);
			ArtworkImage.height = height;
			ArtworkImage.width = width;
			ArtworkWindow.height = height + 23;
			ArtworkWindow.width = width;
			Artworkbarbg.width = width - 40;
			Artworkbarright.hOffset = width;
			ArtworkTitlefield.hOffset = (width / 2) -5;
			ArtworkTitlefield.width = width - 40;
			ArtworkTitlefield.data = currentalbum.Artist + " - " + currentalbum.Title;
			CloseArtbtn.hOffset = width - 20;
			ArtworkWindow.level = (this.Topmost)?"topmost":preferences.konfabulatorWindowLevel.value;
			print("ny ArtworkWindow.level: " + ArtworkWindow.level);
			ArtworkWindow.visible = true;
			ArtworkWindow.focus();
			}
		currentalbum = null;
		}
	, CloseArtworkWindow: function(){
		this.ArtworkAlbumKey = null;
		ArtworkWindow.visible = false;
		ArtworkImage.src = "";
		ArtworkTitlefield.data = "";
		}
	, ShowMiniPopup: function(artworkPath, isNew){
		if(MiniPopupWindow.visible){
			if(!this.OverrideMiniPopup){
				MiniPopupTimer.reset();		
				}
			PopUpArtwork.src = "";
			}
		PopUpArtwork.src = artworkPath;
		PopupNew.visible = (preferences.MiniPopupNewBanner.value==1) && isNew;
		var trackInfo = Player.GetTrack();
		if(trackInfo.IsStream){
			if(trackInfo.Artist!="" && trackInfo.Album!="" && trackInfo.Name!=""){
				PopUpTrackNamefield.data = trackInfo.Name;
				PopUpAlbumfield.data = trackInfo.Album;
				PopUpArtistfield.data = trackInfo.Artist;
				}
			else{
				PopUpTrackNamefield.data = trackInfo.StreamTitle;
				PopUpAlbumfield.data = trackInfo.Name;
				PopUpArtistfield.data =  trackInfo.StreamURL;
				}
			}
		else{
			PopUpTrackNamefield.data = trackInfo.Name;
			PopUpAlbumfield.data = trackInfo.Album;
			PopUpArtistfield.data = trackInfo.Artist;
			}		
		PopUpRating.src = (trackInfo.IsFileTrack && (preferences.MiniPopupRating.value == 1))?"Resources/star"+ fxGetAverageRating(trackInfo.Rating) +".png":"";
		PopUpTimefield.data = (preferences.MiniPopupDuration.value == 1)?trackInfo.Time:"";
		if(!MiniPopupWindow.visible){
			MiniPopupWindow.visible = true;
			if(!this.OverrideMiniPopup){
				MiniPopupTimer.ticking = true;
				}
			}
		MiniPopupWindow.level = "topmost";	
		}
	, CloseMiniPopup: function(){
		MiniPopupWindow.visible = false;
		MiniPopupTimer.ticking = false;
		PopUpArtwork.src = "";
		PopUpTrackNamefield.data = "";
		PopUpAlbumfield.data = "";
		PopUpArtistfield.data = "";
		}
	, SetMiniPopupPosition: function(){
		MiniPopupWindow.vOffset = screen.availHeight - 100;
		MiniPopupWindow.hOffset = screen.availWidth - 220;
		}
	, DiplayCoverFolder: function(){
		filesystem.open(Const.ArtworkFolder);
		}
	, DiplayArtworkImage: function(){
		if(ArtworkWindow.visible){filesystem.reveal(ArtworkImage.src);}
		}
	, SetSnapToTop: function(){
		if(this.SnapToTop){
			MainWindow.locked = false;
			}
		else{
			var position = (screen.availWidth/2) - (MainWindow.width/2);
			MainWindow.moveTo(position, screen.availTop, 1);
			MainWindow.locked = true;
			}
		this.SnapToTop = !this.SnapToTop;
		preferences.SnapToTop.value = (this.SnapToTop? "1":"0");
		savePreferences();
		}
	, SetTopmost: function(){
		if(this.Topmost){
			MainWindow.level = preferences.konfabulatorWindowLevel.value;
			if(this.ArtworkAlbumKey != null){
				ArtworkWindow.level = preferences.konfabulatorWindowLevel.value;
				}
			}
		else{
			MainWindow.level = "topmost";
			if(this.ArtworkAlbumKey != null){
				ArtworkWindow.level = "topmost";
				}
			}
		this.Topmost = !this.Topmost;
		preferences.Topmost.value = (this.Topmost? "1":"0");
		savePreferences();
		}
	};
var Browser = {
	AlbumCount: 0
	, TickSize: 0
	, CurrentIndex: 0
	, Init: function(){
		this.AlbumCount = Albums.Count();
		this.TickSize = (this.AlbumCount  / Slider.Width);
		this.CurrentIndex = 0;
		this.StartArtwork();
		}
	, Reset: function(){
		this.AlbumCount = Albums.Count();
		this.TickSize = (this.AlbumCount /Slider.Width);
		this.CurrentIndex = -1;
		}
	, ResetAlbums: function(){
		album01.src = "";
		album02.src = "";
		album03.src = "";
		album04.src = "";
		album05.src = "";
		reflection01.src = "";
		reflection02.src = "";
		reflection03.src = "";
		reflection04.src = "";
		reflection05.src = "";
		}
	, StartArtwork: function(){
		this.SetAlbum(this.CurrentIndex);
		var a = new Array();
		a.push( new FadeAnimation( AlbumFrame, 255, 1100, animator.kEaseOut ) );
		a.push( new FadeAnimation( AlbumdataFrame, 255, 1100, animator.kEaseOut ) );
		a.push( new FadeAnimation( TotalAlbumsfield, 255, 1100, animator.kEaseOut ) );
		a.push( new FadeAnimation( Ratingstars, 255, 1100, animator.kEaseOut ) );
		animator.runUntilDone( a );
		a = null;
		}
	, EndArtwork: function(){
		Slider.Reset();
		this.CurrentIndex = 0;
		var a = new Array();
		a.push( new FadeAnimation( AlbumFrame, 0, 800, animator.kEaseOut ) );
		a.push( new FadeAnimation( AlbumdataFrame, 0, 800, animator.kEaseOut ) );
		a.push( new FadeAnimation( TotalAlbumsfield, 0, 800, animator.kEaseOut ) );
		a.push( new FadeAnimation( Ratingstars, 0, 800, animator.kEaseOut ) );
		animator.runUntilDone( a );
		a = null;
		}
	, ShowAlbumByPosition: function(position){
		var index = this.GetIndex(position);
		this.ShowAlbum(index);
		}
	, ShowAlbumByIndex: function(index){
		this.ShowAlbum(index);
		Slider.MoveToPosition( this.GetPosition(index) );
		}
	, ShowAlbumByKey: function(key){
		var index = Albums.IndexOf(key);
		if(index != null){
			this.ShowAlbumByIndex(index);
			}
		else{
			UI.ShowResultInfo("No Album found");
			}	
		}
	, ShowNextAlbum: function(){
		if(this.CurrentIndex < this.AlbumCount - 1){
			var index = this.CurrentIndex + 1;
			if(this.AlbumCount > 25){
				this.ShowAlbum(index);
				Slider.SetPosition( this.GetPosition(index) );
				}
			else{
				this.ShowAlbumByIndex(index);
				}
			}
		}
	, ShowPreviousAlbum: function(){	
		if(this.CurrentIndex > 0){
			var index = this.CurrentIndex - 1;
			if(this.AlbumCount > 25){
				this.ShowAlbum(index);
				Slider.SetPosition( this.GetPosition(index) );
				}
			else{
				this.ShowAlbumByIndex(index);
				}
			}
		}
	, ShowFirstAlbum: function(){
		if(this.CurrentIndex != 0){
			this.ShowAlbumByIndex(0);
			}
		}
	, ShowLastAlbum: function(){
		if(this.CurrentIndex != this.AlbumCount - 1){
			Slider.MoveToPosition( Slider.RightBorder );
			this.ShowAlbum(this.AlbumCount - 1);
			}
		}
	, ShowRandomAlbum: function(){
		if( !UI.Busy && !UI.Iconized ){
			if(UI.Minimized){ UI.Minimize(); }
			this.ShowAlbumByIndex(fxRandomNumber(0, this.AlbumCount - 1));
			}
		}
	, ShowAlbum: function(index){
		if(this.CurrentIndex != index){
			this.SetAlbum(index);
			this.CurrentIndex = index;
			}
		}
	, SetAlbum: function(index){
		this.DisplayAlbum(1, index -2);
		this.DisplayAlbum(2, index -1);
		this.DisplayAlbum(3, index);
		this.DisplayAlbum(4, index +1);
		this.DisplayAlbum(5, index +2);
		}
	, DisplayAlbum: function(placement, index){
		if(index >= 0 && index <= this.AlbumCount -1){
			var album = Albums.ItemByIndex(index);
			var path = album.GetThumbnailPath();
			switch (placement){
				case 3:
					album03.src = path;
					var title = album.Title;
					var artist = album.Artist;
					var year = album.Year;
					var rating = fxGetAverageRating(album.AverageRating);
					year = year.toString();
					this.DisplayAlbumData(artist, title, year, album.TrackCount, album.RatedTrackCount, rating);
					var letter;
					switch(UI.SortMethod){
						case 1:
							letter = title.substr(0,1).toUpperCase();
							break;
						case 2:
						case 6:
						case 3:
							letter = artist.substr(0,1).toUpperCase();
							break;
						case 4:
							letter = (year.length == 4)?year.substr(2):"-";
							break;
						case 5:
							letter = rating;
							break;
						case 7:
							letter = album.DateAdded.getUTCFullYear().toString().substr(2);
							break;
						}
					Slider.SetLetter(letter);
					TotalAlbumsfield.data = (index + 1) + " of " + this.AlbumCount + " albums";
					break;
				case 1:
					album01.src = path;
					album01.visible = true;
					break;
				case 2:
					album02.src = path;
					album02.visible = true;
					album02.tooltip = album.Artist +"\n"+ album.Title;
					break;
				case 4:
					album04.src = path;
					album04.visible = true;
					album04.tooltip = album.Artist +"\n"+ album.Title;
					break;
				case 5:
					album05.src = path;
					album05.visible = true;
					break;
				}
			if(UI.AlbumReflection){
				var path = album.GetReflectionPath();
				switch (placement){
					case 3:
						reflection03.visible = true;
						reflection03.src = path;
						break;
					case 1:
						reflection01.visible = true;
						reflection01.src = path;
						break;
					case 2:
						reflection02.visible = true;
						reflection02.src = path;
						break;
					case 4:
						reflection04.visible = true;
						reflection04.src = path;
						break;
					case 5:
						reflection05.visible = true;
						reflection05.src = path;
						break;
					}
				}
			album = null;
			}
		else{
			switch(placement){
				case 1: album01.visible = false; reflection01.visible = false; break;
				case 2: album02.visible = false; reflection02.visible = false; break;
				case 4: album04.visible = false; reflection04.visible = false; break;
				case 5: album05.visible = false; reflection05.visible = false; break;
				}
			}
		}
	, DisplayAlbumData: function(artist, title, year, tracks, ratedtracks, rating){
		Artistfield.data = artist; 
		Albumfield.data = title;
		Yearfield.data = (year.length == 4) ? year : "-";
		Tracksfield.data = tracks +" "+ ((tracks>1)?"tracks":"track") + ((tracks == ratedtracks)?"":" ("+ ratedtracks +" rated)");
		Ratingstars.src = "Resources/star"+ rating +".png";
		}
	, GetIndex: function(position){
		var index = Math.round( (position - Slider.LeftBorder) * this.TickSize);
		return (index >= this.AlbumCount)?this.AlbumCount-1:index;
		}
	, GetPosition: function(index){
		return Math.round((index)/this.TickSize)+Slider.LeftBorder;
		}
	, Scroll: function(){
		if(system.event.scrollDelta > 0 ){
			this.ShowPreviousAlbum();
			}
		else{
			this.ShowNextAlbum();
			}
		}
	}
var Slider = {
	ClickPosition: 0
	, ButtonWidth: Sliderbtn.width
	, LeftBorder: 163
	, RightBorder: 375
	, Width: 0
	, Middle: 0
	, Init: function(){
		this.RightBorder = this.RightBorder - this.ButtonWidth;
		this.Width = (this.RightBorder - this.LeftBorder);
		this.Middle = this.LeftBorder + Math.round((this.Width)/ 2);
		}
	, DragHandler: function(){
		var position = system.event.hOffset - this.ClickPosition;
		if( position > 0 && position <= 500 ){
			if(position <= (this.Middle)){
				position = Math.max(this.LeftBorder, position)
				}
			else{
				position = Math.min(this.RightBorder, position)
				}
			this.SetPosition( position );
			Browser.ShowAlbumByPosition(position);
			}
		position = null;
		}
	, ClickHandler: function(){
		var clickposx = system.event.hOffset;
		var btnposx = this.GetPosition();
		var newposx = 0;
		if(clickposx < btnposx){
			newposx = btnposx - Math.min(20, btnposx - clickposx);
			}
		else if(clickposx > (btnposx + this.ButtonWidth)){	
			newposx = btnposx + Math.min(20, clickposx - (btnposx + this.ButtonWidth));
			}
		else{ return; }
		if(newposx != btnposx){
			this.MoveToPosition( newposx );
			Browser.ShowAlbumByPosition(newposx);
			}
		}
	, MoveToPosition: function(x){
		Sliderfield.visible = false;
		Sliderbtn.moveTo(x, Sliderbtn.vOffset, 0.2);
		Sliderfield.hOffset = x + 14;
		Sliderfield.visible = true;
		}
	, SetPosition: function(x){
		Sliderbtn.hOffset = x;
		Sliderfield.hOffset = x + 14;
		}
	, GetPosition: function(){
		return Sliderbtn.hOffset;
		}
	, SetLetter: function(text){
		Sliderfield.data = text;
		}
	, Reset: function(){
		if(this.GetPosition != this.LeftBorder){
			this.SetLetter("");
			this.MoveToPosition(Slider.LeftBorder);
			}
		}
	};