var Widget = {
	CurrentStatus: ""
	, Sleeping: false
	, Loaded: false
	, TempPref: null
	, Init: function(){
		var needToIndex = false;
		var startiTunes = false;
		try{
			if(!filesystem.itemExists(Const.ArtworkFolder)){
				filesystem.createDirectory(Const.ArtworkFolder);
				}
			if(!filesystem.itemExists(Const.ThumbnailFolder)){
				filesystem.createDirectory(Const.ThumbnailFolder);
				}
			if(!filesystem.itemExists(Const.ReflectionFolder)){
				filesystem.createDirectory(Const.ReflectionFolder);
				}
			if(!filesystem.itemExists(Const.IMFilePath)){
				widget.extractFile("Resources/ImageMagick/convert.exe");
				}
			if(!filesystem.itemExists(Const.GradientImage)){
				widget.extractFile("Resources/reflection_gradient.png");
				}
			if(preferences.Version231Compatible.value == 0){
				if(filesystem.itemExists(Const.HelpFolder)){
					filesystem.remove(Const.HelpFolder);
				}
				fxSetLibraryCompatible("2.3.1");
				}
			if(!filesystem.itemExists(Const.HelpFile) || !filesystem.itemExists(Const.HelpFolder)){
				try{
					filesystem.createDirectory(Const.HelpFolder);
					widget.extractFile("Help/Help.zip");
					filesystem.unzip(system.widgetDataFolder + "/Help.zip", Const.HelpFolder);
					filesystem.remove(system.widgetDataFolder + "/Help.zip");
                	}
                catch(ex){
                	log("__Error extracting help files: " + ex);
                	}
				}
			needToIndex = !filesystem.itemExists(Const.LibraryFilePath);
			startiTunes = (preferences.StartiTunesOnLoad.value == 1);
			if(!needToIndex){
				if(preferences.Version2Compatible.value == 0){
					if(filesystem.itemExists(Const.LibraryFilePath)){
						var version = Source.GetVersion();
						if(version >= "2.0"){
							fxSetLibraryCompatible("2.0");
							}
						else{
							needToIndex = true;
							}
						}
					}
				}
			Library.UseCompilation = (preferences.IndexHandleCompilation.value == 1?true:false);
			UI.SortMethod = parseInt(preferences.SortMethod.value);
			UI.SetSortReversed(preferences.SortReversed.value == 1?true:false);
			UI.SetAutoScroll(preferences.AutoScroll.value == 0?false:true);
			UI.SetDefaultArtwork(preferences.DefaultArtwork.value, false);
			Player.PlaylistName = preferences.PlaylistName.value;
			UI.SetTooltip(preferences.Tooltip.value == 0?false:true);
			UI.MiniPopup = (preferences.MiniPopup.value == 0)?false:true;
			if(preferences.MiniPopupScroll.value == 0){
				PopUpTrackNamefield.scrolling = "off";
				PopUpTrackNamefield.style.KonTextTruncation = "end";
				PopUpAlbumfield.scrolling = "off";
				PopUpAlbumfield.style.KonTextTruncation = "end";
				PopUpArtistfield.scrolling = "off";
				PopUpArtistfield.style.KonTextTruncation = "end";
				}
			UI.OverrideMiniPopup = (preferences.MiniPopupOverride.value == 0)?false:true;
			UI.DockVitality = (preferences.DockVitality.value == 0)?false:true;
			UI.TrackDisplay = (preferences.TrackDisplay.value == 0)?false:true;
			UI.AutoImport = (preferences.AutoImport.value == 0)?false:true;
			UI.SetHotKeys(preferences.HotkeyEnable.value == 0?false:true);
			TrackDisplay.SetTimeType(preferences.TrackDisplayTimeType.value);
			NavigateTimer.interval = preferences.NavigationSpeed.value;
			UI.Topmost = (preferences.Topmost.value == 0)?false:true;
			UI.SnapToTop = (preferences.SnapToTop.value == 0)?false:true;
			Floater.Size = preferences.AlbumWindowSize.value;
			UI.SetAlbumReflection(preferences.AlbumReflection.value == 0?false:true);		
			if(needToIndex){
				if(!startiTunes && !Player.Running){
					if(alert(AlertMsg.StartiTunes, "Yes", "No") == 2){
						closeWidget();
						return;
						}
					}
				Player.RunApplication(!Player.Running);
				this.BuildLibrary();
				}
			else{
				this.FillLibrary();
				if(startiTunes || Player.Running){
					Player.RunApplication( (startiTunes && !Player.Running) );
					}
				else{
					this.CurrentStatus = "wait";
					}
				}
			this.InitUI()
			}
		catch(ex){
			log( "__Error loading widget: " + ex );
			closeWidget();
			}
		}
	, InitUI: function(){
		try{
			Slider.Init();
			Browser.Init();
			switch(preferences.WidgetStateOnLoad.value){
				case "2":
					UI.Minimize();
					break;
				case "3":
					UI.Iconize();
					break;
				}
			PreviousButton.Enable();
			NextButton.Enable();
			SortbyButton.Enable();
			PreferencesButton.Enable();
			AlbumOptionButton.Enable();
			MinimizeButton.Enable();
			iTunesOptionButton.Enable();
			Player.SetStateOnControls();
			if(Player.Running){
				Player.RefreshTrack();
				}
			fxInitTrackDisplay();
			switch(preferences.iTunesStatusMethod.value){
            	case "1":
					StateTimer.interval = 10;
            		StateTimer.onTimerFired = "Player.CheckState();";
            		break;
            	case "2":
					StateTimer.interval = (this.CurrentStatus == "started")?3:10;
            		StateTimer.onTimerFired = "Player.PollState();"
            		break;	
            	}
			StateTimer.ticking = true;
			this.Loaded = true;
			AlbumFrame.onMouseWheel = "Browser.Scroll();";
			if(UI.Topmost){ LevelTimer.ticking = true; }
			if(UI.SnapToTop){ MainWindow.locked = true; }			
			Floater.Init();
			if(preferences.Version22Compatible.value == 0){
				if( Albums.GenerateReflections() ){
					UI.ShowResultInfo("Creating Album Reflections...");
					}
				fxSetLibraryCompatible("2.2");
				}
			}
		catch(ex){
			log( "__Error loading widget UI: " + ex );
			closeWidget();
			}
		}
	, BuildLibrary: function(){
		UI.ShowIndexFrame(true, "Indexing your iTunes Music Library...");
		Library.Build();
		UI.ShowIndexFrame(false,"");
		if(preferences.Version2Compatible.value == 0){
			fxSetLibraryCompatible("2.0");
			fxSetLibraryCompatible("2.2");
			}
		}
	, FillLibrary: function(){
		UI.ShowIndexFrame(true, "Reading Widget Data File...");
		Library.Fill();
		UI.ShowIndexFrame(false,"");
		}
	, RebuildLibrary: function(){
		var answer = alert(AlertMsg.ReIndexLibrary, "Yes", "No");
		if(answer == 1){
			ButtonObjs.forEach( function(btn){ btn.Disable(); } );
			if(UI.Minimized){ 
				UI.Minimize(); 
				}
			if(ArtworkWindow.visible == true){
				UI.CloseArtworkWindow();
				}
			StateTimer.ticking = false;
			Browser.EndArtwork();
			UI.ShowIndexFrame(true, "Indexing your iTunes Music Library...");
			TrackDisplay.Clear();
			Library.Build();
			UI.ShowIndexFrame(false, "");
			StateTimer.ticking = true;
			Browser.Init();
			fxInitTrackDisplay();
			ButtonObjs.forEach( function(btn){ btn.Enable(); } );
			}
		}
	, SetDockInfo: function(artworkpath, rating){
		if(widget.dockOpen){
			var dockxml = XMLDOM.parse( filesystem.readFile( "vitality.xml" ) );
			dockxml.getElementById('artwork').setAttribute("src", artworkpath);
			dockxml.getElementById('artwork').setAttribute("height", (artworkpath == Const.DockImage)?70:75);
			if(rating != null){
				dockxml.getElementById('ratingframe').setAttribute("visible", true);
				dockxml.getElementById('rating').setAttribute("src", "Resources/star"+ fxGetAverageRating(rating) +".png" );
				}
			else{
				dockxml.getElementById('ratingframe').setAttribute("visible", false);
				}
			widget.setDockItem( dockxml, "wipe-left" );
			}
		}
	, Hibernate: function(){
		if(Player.IsRunning()){
			Player.DisconnectEvents();
			if(UI.OverrideMiniPopup){
				UI.CloseMiniPopup();
				}
			if(UI.DockVitality){
				Widget.SetDockInfo(Const.DockImage, null);
				}
			}
		StateTimer.ticking = false;
		this.CurrentStatus = "wait";
		this.Sleeping = true;
		IconImage.src = "Resources/minimized_hibernated.png";
		IconImage.tooltip = fxGetIconTooltip();
		Player.SetStateOnControls();
		}
	, WakeUp: function(){
		StateTimer.ticking = true;
		Player.CheckState();
		this.Sleeping = false;
		IconImage.src = "Resources/minimized.png";
		IconImage.tooltip = fxGetIconTooltip();
		Player.SetStateOnControls();
		if(Player.IsRunning()){
			if(UI.MiniPopup){
				if(Player.IsPlaying()){
					Player.DisplayPlayingTrack();
					}
				}
			if(UI.DockVitality){
				Player.DockPlayingTrack();
				}
			}
		}
	, PreferencesChangedHandler: function(){
		Library.UseCompilation = (preferences.IndexHandleCompilation.value == 1?true:false);
		UI.SetAutoScroll(preferences.AutoScroll.value == 0?false:true);
		UI.AutoImport = (preferences.AutoImport.value == 0)?false:true;
		UI.SetTooltip(preferences.Tooltip.value == 0?false:true);
		NavigateTimer.interval = preferences.NavigationSpeed.value;
		UI.SetHotKeys(preferences.HotkeyEnable.value == 0?false:true);
		UI.MiniPopup = (preferences.MiniPopup.value == 0)?false:true;
		if(UI.MiniPopup == false && preferences.MiniPopupOverride.value == 1){
			UI.CloseMiniPopup();
			}
		MiniPopupTimer.interval = preferences.MiniPopupInterval.value;
		if(this.TempPref.Scroll!= preferences.MiniPopupScroll.value){
			if(preferences.MiniPopupScroll.value == 1){
				PopUpTrackNamefield.scrolling = "autoLeft";
				PopUpTrackNamefield.style.KonTextTruncation = "none";
				PopUpAlbumfield.scrolling = "autoLeft";
				PopUpAlbumfield.style.KonTextTruncation = "none";
				PopUpArtistfield.scrolling = "autoLeft";
				PopUpArtistfield.style.KonTextTruncation = "none";
				}
			else{
				PopUpTrackNamefield.scrolling = "off";
				PopUpTrackNamefield.style.KonTextTruncation = "end";
				PopUpAlbumfield.scrolling = "off";
				PopUpAlbumfield.style.KonTextTruncation = "end";
				PopUpArtistfield.scrolling = "off";
				PopUpArtistfield.style.KonTextTruncation = "end";
				}
			}
		if(this.TempPref.Override != preferences.MiniPopupOverride.value){
			UI.OverrideMiniPopup = (preferences.MiniPopupOverride.value == 0)?false:true;
			if(UI.OverrideMiniPopup){
				MiniPopupTimer.reset();
				MiniPopupTimer.ticking = false;
				if(!MiniPopupWindow.visible){
					Player.DisplayPlayingTrack();
					}
				}
			else{
				UI.CloseMiniPopup();
				}
			}
		if(this.TempPref.Display != preferences.TrackDisplay.value){
			UI.TrackDisplay = (preferences.TrackDisplay.value == 0)?false:true;
			if(!UI.Iconized){
				if(UI.TrackDisplay){
					TrackDisplay.Refresh(false);
					}
				else{
					TrackDisplay.Clear();
					}
				}
			}
		TrackDisplay.SetTimeType(preferences.TrackDisplayTimeType.value);
		if(this.TempPref.ArtworkColor != preferences.DefaultArtwork.value){
			UI.SetDefaultArtwork(preferences.DefaultArtwork.value, true);
			}
		if(this.TempPref.AlbumReflection != preferences.AlbumReflection.value){
			UI.SetAlbumReflection( (preferences.AlbumReflection.value == 0)?false:true );
			if(UI.AlbumReflection){
				Albums.GenerateReflections();
				}
			else{
				if( Widget.TaskHandler.IsRunning() ){
					Widget.TaskHandler.Clear();
					}
				}
			}
		if(this.TempPref.AlbumSize != preferences.AlbumWindowSize.value){
			Floater.SetSize(preferences.AlbumWindowSize.value);
			}
		if(this.TempPref.DockVitality != preferences.DockVitality.value){
			UI.SetDockVitality( (preferences.DockVitality.value == 0)?false:true );
			}
		var playlistName = preferences.PlaylistName.value;
		if(Player.PlaylistName != playlistName){
			if( Player.IsRunning() && playlistName != ""){			
				playlist = Player.GetPlaylist(Player.PlaylistName, true);
				if(playlist != null){
					playlist.Name = playlistName;
					}
				Player.PlaylistName = playlistName;
				}
			else{
				preferences.PlaylistName.value = Player.PlaylistName;
				savePreferences();
				}
			}
		if(UI.Topmost){ 
			MainWindow.level = "topmost"; 
			}
		if(UI.SnapToTop){ MainWindow.locked = true; }
		if(this.TempPref.StatusMethod != preferences.iTunesStatusMethod.value){
			reloadWidget();
			}
		this.TempPref = null;
		}
	, WillChangePreferencesHandler: function(){
		this.TempPref = null;
		this.TempPref = {
			Interval: preferences.MiniPopupInterval.value
			, Scroll: preferences.MiniPopupScroll.value
			, ArtworkColor: preferences.DefaultArtwork.value
			, Display: preferences.TrackDisplay.value
			, AlbumSize: preferences.AlbumWindowSize.value
			, AlbumReflection: preferences.AlbumReflection.value
			, Override: preferences.MiniPopupOverride.value
			, DockVitality: preferences.DockVitality.value
			, StatusMethod: preferences.iTunesStatusMethod.value
			};
		}
	, CheckPosition: function(){
		if(UI.SnapToTop){
			if(MainWindow.vOffset != screen.availTop){
				MainWindow.locked = false;
				MainWindow.vOffset = screen.availTop;
				MainWindow.hOffset = ((screen.availWidth/2) - (MainWindow.width/2));
				MainWindow.locked = true;
				}
			}
		}
	, CheckWindowLevel: function(){
		if(UI.Topmost){
			MainWindow.level = preferences.konfabulatorWindowLevel.value;
			MainWindow.level = "topmost";
			}
		this.CheckPosition();
		LevelTimer.ticking = false;
		}
	, Events: {
			onScreenChangedHandler: function(){
				UI.SetMiniPopupPosition();
				Floater.RestorePositions();
				Widget.CheckPosition();
				}
			, onWakeFromSleepHandler: function(){
				sleep(5000);
				UI.CurrentStatus = "wait";
				StateTimer.ticking = true;
				if(UI.Topmost){LevelTimer.ticking = true;}
				}
			, onPreferencesChangedHandler: function(){
				Widget.PreferencesChangedHandler();
				}
			, onWillChangePreferencesHandler: function(){
				Widget.WillChangePreferencesHandler();
				}
			, onUnloadHandler: function(){
				StateTimer.ticking = false;
				Player.DisconnectEvents();
				Floater.Save();
				if(UI.DockVitality){
					Widget.SetDockInfo(Const.DockImage, null);
					}
				}
			, onRunCommandInBgCompleteHandler: function(tag){
				var data;
				switch (tag){
					case "ReflectionTask":
						data = ReflectionTask;
						break;
					case "OtherTask":
						data = OtherTask
						break;
					}
				Widget.TaskHandler.TaskCompleteHandler(tag, data);
				}
			, onDockOpened: function(){
				Player.DockPlayingTrack();
				}
			, onDockClosed: function(){
				if(UI.DockVitality){
					Widget.SetDockInfo(Const.DockImage, null);
					}
				}
			, OnKeyDownHandler: function(){
				if(system.event.isChar){
					if(system.event.keyCode == 13 || system.event.keyCode == 27){
						return;
						}
					var key = system.event.key;
					if(keySearch == ""){							
						keySearch = key;
						searchTimer.ticking = true;
						}
					else{							
						searchTimer.reset();
						keySearch += key;
						}
					}
				else{
					if(system.event.keyCode == 37 || system.event.keyCode == 39){
						switch(system.event.keyString){
							case "LeftArrow":
								Browser.ShowPreviousAlbum();
								break;
							case "RightArrow":
								Browser.ShowNextAlbum();
								break;
							}
						}
					}
				}
			, OnKeyUpHandler: function(){
				if(system.event.isChar){
					return;
					}
				var keyString = system.event.keyString;
				if(keyString.length > 1){
					switch(keyString){
						case "Home":
							Browser.ShowFirstAlbum();
							break;
						case "End":
							Browser.ShowLastAlbum();
							break;
						case "Return":
						case "Enter":
							UI.AlbumActionHandler();
							break;
						case "Escape":
							UI.CloseSearch();
							break;
						}
					}
				}
		}
	, TaskHandler: {
		_taskqueue: []
		, autostart: false
		, running: false
		, currenttask: null
		, busy: false
		, IsRunning: function(){
			return this.running;
			}
		, Count: function(){
			return this._taskqueue.length;
			}
		, Start: function(){
			if(this.running){
				return;
				}
			if(this.Count() > 0){
				this.running = true;
				this.Shift();
				}
			}
		, Stop: function(){
			this.running = false;
			}
		, Clear: function(){
			if(this.running){
				this.Stop();
				}
			this._taskqueue = [];
			}
		, Shift: function(){
			if(this.running && !this.busy){
				var t = this._taskqueue.shift();
				this.busy = true;				
				this.currenttask = t;
				runCommandInBg(t.Command, t.Tag);
				}
			}
		, Push: function(task){
			this._taskqueue.push(task);
			if(!this.running && this.autostart){
				this.Start();
				}
			}
		, TaskCompleteHandler: function(tag, data){
			var task = this.currenttask;
			if(task.Callback != null){
				task.Callback(task.Reference, data);
				}
			task = null;
			this.currenttask = null;
			this.busy = false;
			if(this.running){
				if(this.Count() > 0){
					this.Shift();
					}
				else{
					this.Stop();
					}
				}
			}
		}
	};
function TaskItem(tag, cmd, ref, callback){
	this.Tag = tag;
	this.Command = cmd;
	this.Reference = ref;
	this.Callback = callback||null;
	}

